/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : PPE robot suiveur de ligne 
Version : 2.1.2a
Date de cration   : 19/03/2008
Dernire mise  jour : 24/04/2010
Author  : Mariano philippe et lves de TS SI                           
Company : Lyce Pierre Emile Martin
1, Avenue de Gionne 18000 BOURGES   
--------------------------------------------------------                             
Comments:  
Les LED et le clavier sont commands par I2C soft.
A l'arrt: Modification des paramtres PWM sur le robot,
test des servos, test des moteurs, test du capteur ligne
et test du capteur constitu de 5 cellules infrarouge.
En dplacement: Affichage de la position du robot par 
rapport  la ligne sur les cinq LED de droite.
Affichage Erreur de mesure sur les trois LED de gauche
Arrt devant la cible et tir (compilation conditionnelle)  
--------------------------------------------------------
Chip type           : ATmega8535 ou ATMEGA32
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
********************************************************/

//============================================================================================================  
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// ATTENTION : Fichier principal du projet (Ne pas modifier sans l'avis du prof)  
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//============================================================================================================

//============================================================================================================
// INFORMATIONS et DECLARATIONS pour la compilation conditionnelle
//------------------------------------------------------------------------------------------------------------
// Les paramtres  rgler avant de compiler sont:
// - 1 La position de la carte "capteur ligne" (Choix: CONNECTEURAR ou CONNECTEURAV)
// - 2 Le microcontrleur cibl (Choix: 	ATMEGA8535 ou ATMEGA32)    
// - 3 La gestion de l'arrt devant la cible (Choix: AVEC_ARRET ou SANS_ARRET)
//------------------------------------------------------------------------------------------------------------
// 1 Position de la carte "capteur ligne" 
// La position de la carte "Capteur Ligne" sur le robot conditionne les valeurs  attribuer aux constantes dans 
// l'numration "Etat_Position_Robot" (voir fichier RB_ELEVE.h)
// Le cas ou le connecteur est orient vers l'avant est slectionn par CONNECTEURAV 
// Le cas ou le connecteur est orient vers l'arrire est slectionn par CONNECTEURAR
#define CONNECTEURAV 	0
#define CONNECTEURAR	1
//------------------------------------------------------------------------------------------------------------
// 2 Microcontrleurs cibls 
#define ATMEGA8535 		1
#define ATMEGA32		2  
//------------------------------------------------------------------------------------------------------------
// 3 Gestion de l'arrt devant la cible 
#define SANS_ARRET		0
#define AVEC_ARRET		1 
//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
// !!!!!!!!!!!!!!!!!! ATTENTION : PARAMETRAGE de la COMPILATION CI-DESSOUS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
//------------------------------------------------------------------------------------------------------------
// Choisir ici le composant cibl par la compilation: 	ATMEGA8535 ou ATMEGA32
#define CIBLE						ATMEGA32
// Choisir ici la position de la carte "capteur ligne": CONNECTEURAR ou CONNECTEURAV
#define POSITIONCONNECTEUR			CONNECTEURAR        
// Choisir ici l'arrt devant la cible: AVEC_ARRET ou SANS_ARRET 
#define PARCOURS_ROBOT				AVEC_ARRET
//============================================================================================================

//============================================================================================================
// Bibliothques   
//------------------------------------------------------------------------------------------------------------ 
// CVAVR
//------------------------------------------------------------------------------------------------------------
#if CIBLE == ATMEGA8535 
#include <mega8535.h> 
#elif  CIBLE == ATMEGA32
#include <mega32.h>
#endif

#include <delay.h>
#include <stdio.h>       
#include <stdlib.h>
#include <string.h>
#include <math.h>
//------------------------------------------------------------------------------------------------------------
// Bibliothques dveloppes pour la carte SISI
//------------------------------------------------------------------------------------------------------------							
#include "sisisvl.h"  		// Lire_BP_I2C_Soft, Affiche_LCD, Arret_Moteurs, Active_Moteurs, Affiche_Fleche 
#include "PCF8574.h"        // Ecrire_Port_I2C_Soft, Lire_Port_I2C_Soft  
#include "RBELEVE.h"        // Paramtres du capteur ligne et paramtres de commande des moteurs
//============================================================================================================

//============================================================================================================
// Dclarations  
//------------------------------------------------------------------------------------------------------------
// I2C Bus functions
#asm
   .equ __i2c_port=0x18
   .equ __sda_bit=1
   .equ __scl_bit=0
#endasm
#include <i2c.h>

// Alphanumeric LCD Module functions   
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>  
//============================================================================================================

//============================================================================================================
// CONSTANTES
//------------------------------------------------------------------------------------------------------------
// Constantes en eeprom
//------------------------------------------------------------------------------------------------------------
/// Table des valeurs de rglage des signaux PWM en eeprom  ( initialiser avec le fichier EEPROMROBOTBASE.eep 
// lors de la premire mise en oeuvre du robot (Voir prof)
//------------------------------------------------------------------------------------------------------------ 
eeprom unsigned char PWM_EEPROM[11][2];
// Organisation de la table	PWM_EEPROM[11][2]  
//	Position	 MG    MD
//   n          [n,0] [n,1]
// Centre       val00  val01
// Droite
// Droite+
// Droite2+
// Droite3+
// HorsLigneD
// Gauche
// Gauche+
// Gauche2+
// Gauche3+
// HorsLigneG
//------------------------------------------------------------------------------------------------------------
// Constantes en flash
//------------------------------------------------------------------------------------------------------------
// Tables des caractres personnaliss:  placer dans la mmoire CGRAM du LCD  
//------------------------------------------------------------------------------------------------------------
const unsigned char flecheHaut[] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};    // @1 CGRAM
const unsigned char flecheBas[] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};     // @2 CGRAM
//============================================================================================================


//============================================================================================================
// Variables globales
//------------------------------------------------------------------------------------------------------------ 
// type		   	   		nom						   				Commentaires
//------------------------------------------------------------------------------------------------------------
// Tableau des structures des menus "Rglage des paramtres PWM"  
//------------------------------------------------------------------------------------------------------------
flash struct Affichage_reglages {
		char ligne0[14]; // 12 caractres + fin de ligne arrondi  l'entier pair suprieur
		char ligne1[14]; // Ligne0 = 1er ligne de l'affichage 
		} Tab_Aff_Reg[11]= {{"Centre MG  =","Centre MD  ="},
				    {"Droite MG  =","Droite MD  ="},
				    {"Droite+ MG =","Droite+ MD ="},
				    {"Droite2+ MG=","Droite2+ MD="},
				    {"Droite3+ MG=","Droite3+ MD="},
				    {"HorLigD MG =","HorLigD MD ="},
				    {"Gauche MG  =","Gauche MD  ="},
				    {"Gauche+ MG =","Gauche+ MD ="},
				    {"Gauche2+ MG=","Gauche2+ MD="},
				    {"Gauche3+ MG=","Gauche3+ MD="},
				    {"HorLigG MG =","HorLigG MD ="}};
//------------------------------------------------------------------------------------------------------------ 
// Etats du graphe des transitions des menus                        				
//------------------------------------------------------------------------------------------------------------
enum TMenu {Menu_Reglages, Menu_Run, Menu_Tests, Menu_Test_Servos, Menu_Test_Moteurs, Cde_Moteurs,  
       Reglage_PWM, Activation, Menu_Test_Capteurs_Ligne, Menu_Test_Capteurs_Cible, Affiche_Reglages, Cde_Servo,
       Visu_Position,Visu_Cible  } Menu=Menu_Reglages, Menu_1=Menu_Run; // Etats du graphe tests          
//------------------------------------------------------------------------------------------------------------
// Diffrentes commandes des moteurs 											
//------------------------------------------------------------------------------------------------------------
enum Etat_Commande_Moteur {DEPART,CDE_CENTRE, CDE_CENTRE2, CDE_CENTRE3, CDE_DROITE, CDE_DROITE_PLUS, 
CDE_DROITE_2PLUS, CDE_DROITE_3PLUS, CDE_GAUCHE, CDE_GAUCHE_PLUS, CDE_GAUCHE_2PLUS, CDE_GAUCHE_3PLUS,
CDE_HORS_LIGNE_GAUCHE, CDE_HORS_LIGNE_DROITE, CDE_COUPURE } EtatCdeMot = DEPART;
//------------------------------------------------------------------------------------------------------------ 
//------------------------------------------------------------------------------------------------------------
// Pour la dtection de la cible (utilis dans INT0, dans le menu VisuCible et par le SP Mode_RUN) 
//------------------------------------------------------------------------------------------------------------
bit Cible=0;         // cible = 0 => pas de dtection, cible = 1 => dtection 
#if PARCOURS_ROBOT == AVEC_ARRET 
bit Cible_1 = 1;     
#endif
//============================================================================================================

//============================================================================================================
// Prototype des fonctions places  la fin du fichier 
//------------------------------------------------------------------------------------------------------------ 
// Ces sous programmes se situent dans le fichier RB_ELEVE.c que les lves doivent complter 
void Mode_Run(void);        	// SP Suivi de ligne  
#if PARCOURS_ROBOT == AVEC_ARRET  
void Gestion_Balle(void);		// SP Gestion de la balle
#endif
//============================================================================================================


//============================================================================================================
// Sous programme d'interruption dclench sur un front descendant de INT0 
// (Dtection de la cible par un contact reed ferm par la prsence d'un aimant)
//------------------------------------------------------------------------------------------------------------
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
// Dsactivation de l'INT0
GICR=0x00; // Dsactivation INT0 (bit6 de GICR)
Arret_Moteurs();  // Arrt du robot
Cible = 1; 
}
//============================================================================================================  

//============================================================================================================  
//============================================================================================================
// Programme principal
//============================================================================================================
//============================================================================================================
void main(void)
{ // Dbut du main
//============================================================================================================
// Variables locales  la fonction principale 
//------------------------------------------------------------------------------------------------------------
// type	   			nom			   					Commentaires
//------------------------------------------------------------------------------------------------------------
unsigned char BP,Code_BP;						// Etat des boutons-poussoirs de la carte SISI
unsigned char i;                        		// Compteur d'usage gnral
unsigned char NumServo=1, NumServo_1=1;			// Saisie du numro du servo
unsigned char Aff_Cde_Servo=0, Aff_Cde_Servo_1=0; 	// Valeur  envoyer au servo slectionn dans le menu Cde_Servo  
unsigned char decompte=5, decompte_1=5;			// Temporisation avant le passage en mode RUN
int i_n=0, i_n_1=1; 							// Indices du tableau des structures d'affichage 
char display_buffer_ligne0[17]; 				// Tampon ligne 0 de l'afficheur LCD (16 caractres + /0)
char display_buffer_ligne1[17]; 				// Tampon ligne 1 de l'afficheur LCD            "
char pourcentage0[3], pourcentage1[3];  		// Affichage pourcentage PWM (0->95) (2 caractres + /0)
unsigned char rcycl=0, rcycl_1=0;       		// Saisie du rapport cyclique lors d'une modification manuelle
// Tableau des coefficients placs dans OCR1x pour le test "rglage du rapport cyclique du signal PWM"
unsigned char alpha[11] = {0,25,51,76,102,127,153,178,204,229,255}; 
unsigned char Cde_Del_IR;						// Permet de multiplexer la commande des LEDs des capteurs IR     
//============================================================================================================

//============================================================================================================
// Initialisations
//------------------------------------------------------------------------------------------------------------
// Initialisation des priphriques
//------------------------------------------------------------------------------------------------------------                                        
// Input/Output Ports initialization
// Port A initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
// State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=1 State7=1 
				// Gestion des Emetteurs_IR 
PORTA=0xFF; 	// Dsactivation des E_IR  la mise sous tension
DDRA=0xFF;		// Port en sortie

// Port B initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=Out Func7=Out
// State0=T State1=T State2=T State3=T State4=T State5=T State6=0 State7=0
PORTB=0x00;        // SERVO1 sur PB6, SERVO2 sur PB7
DDRB=0xC0;

// Port C initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
            // Gestion de l'afficheur LCD
PORTC=0x00; // Gre l'affichage, initialis par la fonction lcd_init(16);
DDRC=0x00;    

// Port D initialization 
// Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=In Func6=Out Func7=In
// State0=T State1=T State2=T State3=0 State4=T State5=T State6=0 State7=T
				// Capteur magntique, moteurs, S4 et liaison srie
PORTD=0x30;     // Capteur magntique reli au 0V sur PD2
DDRD=0xF0; 		// Broches PWM moteurs droit et gauche en sortie, initialise  1 
				// Cde Servo 1 et 2 en sortie, Initialises  0

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Inverted
// OC1B output: Inverted
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0xF1; // 0xA1 pour robot 2008, 0xF1 pour robot 2009
TCCR1B=0x01;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
// INT2: Off
GICR|=0x40;
MCUCR=0x02;
MCUCSR=0x00;
GIFR=0x40;

// Analog Comparator initialization
// Analog Comparator: On
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x00;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);
//------------------------------------------------------------------------------------------------------------
// Chargement initial de la mmoire CGRAM de l'afficheur avec deux caractres personaliss  
//------------------------------------------------------------------------------------------------------------
for (i=0;i<8;i++)
{
 lcd_write_byte(Add_FlecheH_CGRAM + i, flecheHaut[i]); 	// @1 Caractre flche haut
 lcd_write_byte(Add_FlecheB_CGRAM + i, flecheBas[i]); 	// @2 Caractre flche bas
}
//------------------------------------------------------------------------------------------------------------
// Initialisation de la position des Servos
CDE_SERVO1 = 0;
CDE_SERVO2 = 0;
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
// Message d'accueil
//------------------------------------------------------------------------------------------------------------
lcd_clear();
sprintf(display_buffer_ligne0,"****V_2.1.2a****"); // Version du logiciel  remplacer par le nom du robot
sprintf(display_buffer_ligne1,"---PEM BOURGES--");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);   
delay_ms(3000);
//============================================================================================================ 

//============================================================================================================
// Boucle principale
//------------------------------------------------------------------------------------------------------------
while (1)
{    
  BP = Lire_BP_I2C_Soft(); 						// Lecture BP pour volution du graphe des menus 
  												// Gestion anti-rebonds     
  Code_BP =  Lire_Port_I2C_Soft(Add_BP_I2C); 	// Lecture BP pour affichage sur les LED
  												// Code BP = Code LED
   
   switch (Menu)
   {// Dbut du switch principal    
//============================================================================================================
// Dbut Menus droulants 
///============================================================================================================
// Dbut Menus droulants de NIVEAU 1 
//------------------------------------------------------------------------------------------------------------
      case Menu_Reglages : if (Menu_1 != Menu)
                       		{
                        		sprintf(display_buffer_ligne0,"1 Regl coef Mot ");
                       			sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
                    			Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                       			Affiche_Fleche();
                       		}
                      
                         	switch(BP)
                         	{                                   
                      	   		case FlecheB_I2C: Menu = Menu_Tests;  break; // touche [flche bas]
                      	   		case FlecheH_I2C: Menu = Menu_Run;  break; // touche [flche haut]  
                      	   		case ENTR_I2C: Menu = Affiche_Reglages;  break; // touche [Enter]
                      	   		default: Menu = Menu_Reglages;
                      	 	}
                       
       		         		Menu_1 = Menu_Reglages;
       break; 
       
       case Menu_Run : if (Menu_1 != Menu)
                       		{
                        		sprintf(display_buffer_ligne0,"2 Activ. Robot  ");
                    			sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
                    			Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                    			Affiche_Fleche();
                       		}
                      
                        	switch(BP)
                         	{         
                      	   		case FlecheB_I2C: Menu = Menu_Reglages; break; // touche [flche bas]
                      	   		case FlecheH_I2C: Menu = Menu_Tests; break; // touche [flche haut]
                      	   		case ENTR_I2C: Menu = Activation; break; // touche [Enter]
                      	   		default: Menu = Menu_Run;
                      	 	}
                       
       		        		Menu_1 = Menu_Run;
       break;      
       
       case Menu_Tests : if (Menu_1 != Menu)
       					 	{
                          		sprintf(display_buffer_ligne0,"3 Test du Robot ");
                    	  		sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
                    	  		Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                    	  		Affiche_Fleche();
                         	} 
                       
                       		switch(BP)
                         	{                                  
                      	   		case FlecheB_I2C: Menu = Menu_Run;  break; // touche [flche bas]
                      	   		case FlecheH_I2C: Menu = Menu_Reglages;  break; // touche [flche haut]
                      	   		case ENTR_I2C: Menu = Menu_Test_Servos;  break; // touche [Enter]
                      	   		default: Menu = Menu_Tests ;
                      	 	}
                       
       		         		Menu_1 = Menu_Tests;
       
       break; 
//------------------------------------------------------------------------------------------------------------          
// Fin Menus droulants de NIVEAU 1 
//============================================================================================================ 
//============================================================================================================   
// Dbut Menus droulants de NIVEAU 2 
//------------------------------------------------------------------------------------------------------------    
       case Menu_Test_Servos : if (Menu_1 != Menu)
                       		{
                        		sprintf(display_buffer_ligne0,"3.1 Test Servos ");
                    			sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
                       			Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                    			Affiche_Fleche();
                       		}
                      
                      		switch(BP)
                      		{                                  
                      	   		case FlecheB_I2C: Menu = Menu_Test_Capteurs_Cible;  break; 	// touche [flche bas]
                      	   		case FlecheH_I2C: Menu = Menu_Test_Moteurs;  break; 		// touche [flche haut]
                      	   		case ECHAP_I2C: Menu = Menu_Tests; break; 					// touche [Echap]
                      	   		case ENTR_I2C: Menu = Cde_Servo;               				// touche [Enter] 
                      	   						Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;  
                      	   		break; 			
                      	   		default: Menu = Menu_Test_Servos;
                      	 	}
                       
       		         		Menu_1 = Menu_Test_Servos;
       break; 
 
       case Menu_Test_Moteurs : if (Menu_1 != Menu)
                        	{ 
                         		sprintf(display_buffer_ligne0,"3.2 Tst Moteurs ");
                    	 		sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
                    	 		Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                    	 		Affiche_Fleche();
                        	}  
                         
                         	switch(BP)
                         	{   
                           		case FlecheB_I2C: Menu = Menu_Test_Servos;  break; // touche [flche bas]  
                           		case FlecheH_I2C: Menu = Menu_Test_Capteurs_Ligne;  break; // touche [flche haut]
                      	   		case ECHAP_I2C: Menu = Menu_Tests; break; // touche [Echap]                          
                      	   		case ENTR_I2C: rcycl = 0; rcycl_1 = 0; Menu = Cde_Moteurs;  break; // touche [Enter] 
                      	   		default: Menu = Menu_Test_Moteurs;
                      	 	}
                       
       		         		Menu_1 = Menu_Test_Moteurs;    
        break;
        
       case Menu_Test_Capteurs_Ligne : if (Menu_1 != Menu)
                        	{ 
                         		sprintf(display_buffer_ligne0,"3.3 Tst CptLign ");
                    	 		sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
                    	 		Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                    	 		Affiche_Fleche();
                        	}
                        	  
                         	switch(BP)
                         	{ 
                           		case FlecheB_I2C: Menu = Menu_Test_Moteurs;  break; 	// touche [flche bas]
                           		case FlecheH_I2C: Menu = Menu_Test_Capteurs_Cible;  break; 	// touche [flche haut]
                      	   		case ECHAP_I2C: Menu = Menu_Tests; break; 			// touche [Echap]                                 
                      	   		case ENTR_I2C: Menu = Visu_Position;  break; 		// touche [Enter] 
                    	   		default: Menu = Menu_Test_Capteurs_Ligne;
                      	 	}
                       
       		         		Menu_1 = Menu_Test_Capteurs_Ligne;    
        break; 
        
        case Menu_Test_Capteurs_Cible : if (Menu_1 != Menu)
                        	{ 
                         		sprintf(display_buffer_ligne0,"3.4 Tst CptCibl ");
                    	 		sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
                    	 		Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                    	 		Affiche_Fleche();
                        	}
                        	  
                         	switch(BP)
                         	{ 
                           		case FlecheB_I2C: Menu = Menu_Test_Capteurs_Ligne;  break; 	// touche [flche bas]
                           		case FlecheH_I2C: Menu = Menu_Test_Servos;  break; 	// touche [flche haut]
                      	   		case ECHAP_I2C: Menu = Menu_Tests; break; 			// touche [Echap]                                 
                      	   		case ENTR_I2C: Menu = Visu_Cible; 					// touche [Enter] 
                      	   						#if PARCOURS_ROBOT == AVEC_ARRET  
                      	   						#asm("sei");
                      	   						#endif
                      	   		break; 	
                    	   		default: Menu = Menu_Test_Capteurs_Cible;
                      	 	}
                       
       		         		Menu_1 = Menu_Test_Capteurs_Cible;    
        break; 

       case Affiche_Reglages : if ((Menu_1 != Menu) || (i_n_1 != i_n))   // Affichage des rglages PWM sous la forme d'un menu droulant
                         {
                         if (fmod(i_n,2)==0) // Cas1: si l'indice i_n permettant de parcourir le tableau AFFICHE_REGLAGE est pair
                             {
                        	sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0); // Cas1: Affichage ligne (i_n/2) colonne 0 sur ligne 0 afficheur
                        	itoa(PWM_EEPROM[i_n/2][0],pourcentage0);
                        	strcat(display_buffer_ligne0,pourcentage0);
                       		sprintf(display_buffer_ligne1,Tab_Aff_Reg[i_n/2].ligne1); // Cas1: Affichage ligne (i_n/2) colonne 1 sur ligne 1 afficheur
                       		itoa(PWM_EEPROM[i_n/2][1],pourcentage1);
                       	        strcat(display_buffer_ligne1,pourcentage1);
                       		}
                       		else  // si l'indice i_n permettant de parcourir le tableau AFFICHE_REGLAGE est impair
                       		 { 
                        	   sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);  // Cas2et3: Affichage ligne (i_n/2) colonne 1 sur ligne 0 afficheur
                                   itoa(PWM_EEPROM[i_n/2][1],pourcentage0);
                                   strcat(display_buffer_ligne0,pourcentage0);
                                
                                   if (i_n < 21) // et si la fin de la table AFFICHE_REGLAGE n'est pas atteinte 
                                    { 	
                       		      sprintf(display_buffer_ligne1,Tab_Aff_Reg[(i_n/2)+1].ligne0); // cas2: Affichage ligne ((i_n/2)+1) colonne 0 sur ligne 1 afficheur
                       	              itoa(PWM_EEPROM[(i_n/2)+1][0],pourcentage1);
                       	 	      strcat(display_buffer_ligne1,pourcentage1);
                       	            }
                       	            else // et si la fin de la table AFFICHE_REGLAGE est atteinte 
                       	            {
                       		     sprintf(display_buffer_ligne1,Tab_Aff_Reg[0].ligne0); // cas3: Affichage ligne 0 colonne 0 sur ligne 1 afficheur
                       	             itoa(PWM_EEPROM[0][0],pourcentage1);
                       	 	     strcat(display_buffer_ligne1,pourcentage1);
                       	            }
                       	         }
                    		Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                    		lcd_gotoxy(14,0);
                    		lcd_putchar('%');
                    		lcd_gotoxy(15,0);	// Affichage flecheHaut
							lcd_putchar(Caractere_FlecheH);
							lcd_gotoxy(14,1);
                    		lcd_putchar('%');	
							lcd_gotoxy(15,1);	// Affichage flecheBas
							lcd_putchar(Caractere_FlecheB);
							i_n_1 = i_n; // Notifie que l'affichage a chang
                       		  }
                      
                         switch(BP)
                         { 
                      	   // Gestion de l'indice i_n du tableau AFFICHE_REGLAGE dans l'intervalle [0,21]
                      	   case FlecheH_I2C: if (i_n < 21) i_n++; else i_n=0; break; // touche [flche haut]
                      	   case FlecheB_I2C: if (i_n > 0) i_n--; else i_n=21; break; // touche [flche bas]
                      	   case ECHAP_I2C: Menu = Menu_Reglages; break; 	    // touche [Echap]
                      	   // La touche [Enter] fait passer la donne prsente sur la premire 
                           // ligne de l'afficheur en mode modification                                 
                      	   case ENTR_I2C:  if (fmod(i_n,2)==0) // si i_n pair     
                      	                 rcycl = PWM_EEPROM[i_n/2][0];
                      	   	     else  // si i_n impair   
                      	   	           rcycl = PWM_EEPROM[i_n/2][1];
                      	   	         
                      	             Menu = Reglage_PWM;  
                      	   break;  
                      	   default: Menu = Affiche_Reglages;
                      	 }
                       
       		       		Menu_1 = Affiche_Reglages;
       break;   
//------------------------------------------------------------------------------------------------------------           
// Fin Menus droulants de NIVEAU 2 
//============================================================================================================
// Fin Menus droulants
//============================================================================================================
               
        case Reglage_PWM : if ((Menu_1 != Menu)|| (rcycl_1 != rcycl))
                       { 
                        if (fmod(i_n,2)==0) // si i_n pair
                           { 
                             sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0);
                             itoa(rcycl,pourcentage0);
                             strcat(display_buffer_ligne0,pourcentage0);
                           }
                        else  // si i_n impair
                           {
                             sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);
                             itoa(rcycl,pourcentage0);
                             strcat(display_buffer_ligne0,pourcentage0);
                           }
                    	sprintf(display_buffer_ligne1,"ENTR>Memo [ECH]");
                    	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                    	lcd_gotoxy(15,0);
						lcd_putchar('+');
						lcd_gotoxy(15,1);
						lcd_putchar('-');
						rcycl_1 = rcycl; // Notifie que l'affichage a chang
                       }
                      
                         switch(BP)
                         { // Rglage du rapport cyclique par pas de 5%
                           case MOINS_I2C: if (rcycl > 5) rcycl = rcycl-5; else rcycl = 0; break; // touche [-] 
                           case PLUS_I2C: if (rcycl < 100) rcycl = rcycl+5; else rcycl = 100; break; // touche [+]
                           case ECHAP_I2C: Menu = Affiche_Reglages;  break; // touche [Echap]
                           case ENTR_I2C: if (fmod(i_n,2)==0) // si i_n pair touche [Entr]
                      	                  PWM_EEPROM[i_n/2][0]=rcycl;
                      	   	     else // si i_n impair
                      	   	          PWM_EEPROM[i_n/2][1]=rcycl;
                      	   	     
                      	   	     Menu = Affiche_Reglages;     
                      	   break;                                  
                      	   default: Menu = Reglage_PWM;
                      	 }
                       
       		       Menu_1 = Reglage_PWM;
       break;   
       
       case Activation : if ((Menu_1 != Menu) || (decompte != decompte_1))
                       {
                        sprintf(display_buffer_ligne0,"Depart dans %-us",decompte);
                    	sprintf(display_buffer_ligne1,"[Ech]>Desactiver");
                    	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                    	decompte_1 = decompte; // Notifie que l'affichage a chang
                       }
                       
                     	 if (BP==ECHAP_I2C) { // touche [Echap] pour sortir du dcompte
                                   				decompte=5; // Rglage 5s
                                   				Menu=Menu_Reglages;
                                   				break;
                     		 				}
                         else if(decompte == 0) 
                     		       				Mode_Run();
                     delay_ms(1000); decompte--;
                     Menu_1 = Activation;
      break; 
      
      case Cde_Servo : if ((Menu_1 != Menu) || (NumServo != NumServo_1)|| (Aff_Cde_Servo != Aff_Cde_Servo_1))
                       {
                        sprintf(display_buffer_ligne0,"Cde Servo_%-u= %-u   ",NumServo,Aff_Cde_Servo);
                    	sprintf(display_buffer_ligne1,"[+] [-] [Echp]  ");
                    	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                    	Affiche_Fleche();
                    	NumServo_1 = NumServo; // Notifie que l'affichage a chang
                    	Aff_Cde_Servo_1 = Aff_Cde_Servo;
                       }
                       
                       switch(BP)
                         { 
                           case MOINS_I2C: 	 									// touche [-]
                     						if (NumServo==1) {CDE_SERVO1 = 0; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}					
                      	   					if (NumServo==2) {CDE_SERVO2 = 0; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}	
                      	   break; 
                      	  
                      	   case PLUS_I2C: 				 					// touche [+]
                           					if (NumServo==1) {CDE_SERVO1 = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}					
                      	   					if (NumServo==2) {CDE_SERVO2 = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
                      	   break; 

                      	   case ECHAP_I2C: 	CDE_SERVO1 = 0; CDE_SERVO2 = 0; 	// touche [Echap] 
                      	   					Menu = Menu_Test_Servos; 
                      	   break;
                      	   
                      	   case FlecheB_I2C: if (NumServo == 1) {NumServo = 2; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
                      	   		   		else if (NumServo == 2) {NumServo = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}
                      	   break;
                      	   
                      	   case FlecheH_I2C: if (NumServo == 1) {NumServo = 2; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
                      	   		   		else if (NumServo == 2) {NumServo = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}
                      	   break;
                      	   
                      	   default: Menu = Cde_Servo;
                      	 } 
                      	 
                     Menu_1 = Cde_Servo;
      break;
      
      
        
      case Cde_Moteurs :  if ((Menu_1 != Menu)|| (rcycl_1 != rcycl))
       			  		  {
       		   	    	   sprintf(display_buffer_ligne0,"Rap. cycl = %-u%%",rcycl);
       		               sprintf(display_buffer_ligne1,"[+] [-] [Echap] ");
       		               Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
       		               rcycl_1 = rcycl; 
			  			  }   
			  
		           	  	  switch(BP)
			               {  
			        		case MOINS_I2C: if (rcycl > 10) rcycl = rcycl-10; else rcycl = 0; break; // touche [-]
							case PLUS_I2C: if (rcycl < 90) rcycl = rcycl+10; else rcycl = 100; break; // touche [+]
							case ECHAP_I2C : rcycl = 0; Menu = Menu_Test_Moteurs; break; // touche [Echap]
				   			default: Menu = Cde_Moteurs;
                           }
                                 
                        // Transfert des rapports cycliques      
							OCR1AL=alpha[rcycl/10];
							OCR1BL=alpha[rcycl/10];
         					Menu_1 = Cde_Moteurs ;      		      
     break;           
     
     case Visu_Position :       // ------------------------------------------------------------------------------------
								// Fonction acqurir la position du robot par rapport  la ligne
								// ------------------------------------------------------------------------------------
      							Position_Robot = HORS_LIGNE; // Initialisation  0	
      							Cde_Del_IR = 1; 
 
 				for (i=0;i<5;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
       				{
        			  CAPTEUR_IR = ~Cde_Del_IR;
      				  delay_us(30);	// Temps d'activation d'un capteur ( ajuster : 9s par dfaut)
        			  if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;
        			  CAPTEUR_IR = 0xFF;
        			  Cde_Del_IR = Cde_Del_IR << 1 ;
        			  delay_us(540); //  ajuster   (540s par dfaut)
       				} 
       				
       				delay_us(1500);
       				// Fin Acquisition de la position du robot par rapport  la ligne
				// ------------------------------------------------------------------------------------ 
				
     				if ((Menu_1 != Menu)|| (Position_Robot != Position_Robot_1))
     			        {
						// ------------------------------------------------------------------------------------
						// Fonction Visualiser (Visualisation des capteurs sur la ligne)
						// ------------------------------------------------------------------------------------
				 	switch (Position_Robot)              
       				 { 
       				  case HORS_LIGNE:  	sprintf(display_buffer_ligne0,"Pos = Hors ligne"); break; // Hors ligne
       				  case GAUCHE_3PLUS:  	sprintf(display_buffer_ligne0,"Pos = Gauche 3+ "); break; // Gauche3+
  				  	  case GAUCHE_2PLUS:  	sprintf(display_buffer_ligne0,"Pos = Gauche 2+ "); break; // Gauche2+
       				  case CENTRE_1:  		sprintf(display_buffer_ligne0,"Pos = Centre    "); break; // Centre1 non visualis
        			  case GAUCHE_PLUS:  	sprintf(display_buffer_ligne0,"Pos = Gauche +  "); break; // Gauche+  
        			  case CENTRE_3: 		sprintf(display_buffer_ligne0,"Pos = Centre    "); break; // Centre3 
        			  case GAUCHE: 			sprintf(display_buffer_ligne0,"Pos = Gauche    "); break; // Gauche 
        			  case DROITE_3PLUS: 	sprintf(display_buffer_ligne0,"Pos = Droite 3+ "); break; // Droite3+
        			  case DROITE_2PLUS: 	sprintf(display_buffer_ligne0,"Pos = Droite 2+ "); break; // Droite2+  
        			  case DROITE_PLUS: 	sprintf(display_buffer_ligne0,"Pos = Droite +  "); break; // Droite+ 
        			  case DROITE: 			sprintf(display_buffer_ligne0,"Pos = Droite    "); break; // Droite 
        			  case CENTRE_5: 		sprintf(display_buffer_ligne0,"Pos = Centre    "); break; // Centre5 
        			  default: 				sprintf(display_buffer_ligne0,"Pos = ?????     "); // Erreur mesure
       				 }   
     			        
       				sprintf(display_buffer_ligne1,"         [ECHAP]");
       				Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
       				Position_Robot_1 = Position_Robot;
           			}
     			
     				if (BP == ECHAP_I2C) Menu = Menu_Test_Capteurs_Ligne; // touche [Echap]
     			 		else Menu = Visu_Position;
     			 		
           		Menu_1 = Visu_Position;
      break;  
      
      
      #if PARCOURS_ROBOT == AVEC_ARRET
      case Visu_Cible:  GICR=0x40; // Activation INT0
      			    	if ((Menu_1 != Menu)|| (Cible != Cible_1))
      			    	{ 
      						switch (Cible) // Cible passe  1 lorsque le robot est devant la cible  
      						{
      						 case 0: sprintf(display_buffer_ligne0,"Regler pos capt.");
      						 break;
      						  
      						 case 1: sprintf(display_buffer_ligne0,"Pos capteur Ok  ");
      						 		 Cible = 0;   
        					 break; 	
        					}
        					
        					sprintf(display_buffer_ligne1,"         [ECHAP]");      
       						Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
       				  		Cible_1 = Cible;
                    	}
                    	
     					if (BP == ECHAP_I2C) 					// touche [Echap]
     						{
     							Menu = Menu_Test_Capteurs_Cible; 
     							Active_Moteurs();  // Ractivation PWM (Dsactive dans l'INT0)
     							#asm("cli")
     						}
     			 	   		else Menu = Visu_Cible;
      
      					Menu_1 = Visu_Cible;
      break; 
      
      #elif PARCOURS_ROBOT == SANS_ARRET 
      case Visu_Cible:  if (Menu_1 != Menu)
      			    	{
      			    	   sprintf(display_buffer_ligne0,"!Test desactive!");
      			    	   sprintf(display_buffer_ligne1,"Compil Avec_Arre"); 
      			    	   Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
      			    	} 
      			    		if (BP == ECHAP_I2C) 					// touche [Echap]
     						{
     							Menu = Menu_Test_Capteurs_Cible; 
     						}
     			 	   		else Menu = Visu_Cible;
      
      					Menu_1 = Visu_Cible;
      break; 
      #endif
                                                           
  } // Fin du switch principal 
//============================================================================================================ 
  Ecrire_Port_I2C_Soft(Add_LED_I2C,~Code_BP); // Visualisation de la position du robot sur les LED
//============================================================================================================
 } // Fin du while(1)
//============================================================================================================
} // fin du main 
//============================================================================================================  
// Lien vers le travail Elve  : SOUS-PROGRAMME Mode_RUN()
//------------------------------------------------------------------------------------------------------------    
#include "RB_ELEVE.c" 
//============================================================================================================
//============================================================================================================
// ******************************** SOUS-PROGRAMME SUIVI DE LIGNE ELEVE **************************************
//============================================================================================================
//============================================================================================================
// 	Mode_Run() : LE ROBOT EFFECTUE SON PARCOURS
//------------------------------------------------------------------------------------------------------------
// !!!!!!!!! Attention : on sort du menu Mode_Run par une coupure d'alimentation !!!!!!!!
//============================================================================================================
void Mode_Run()
{
//------------------------------------------------------------------------------------------------------------ 
// Variables locale  Mode_Run()  
//------------------------------------------------------------------------------------------------------------
// type			nom						Commentaires
//------------------------------------------------------------------------------------------------------------ 
unsigned char i,j,k;            // Compteurs des boucles utilises pour transfrer en RAM, les valeurs 
								// correspondant aux %rapports cycliques sauvegardes dans l'eeprom
unsigned char VisuPosition;		// Contient la valeur transmise aux Leds pendant le dplacement 
unsigned char PWM[11][2];		// Contient les coefficients destins au Timers(PWM) pour le rglage de la 
								// frquence de rotation des moteurs. 
unsigned char Cde_Del_IR;		// Permet de multiplexer la commande des Leds des capteurs IR

#if PARCOURS_ROBOT == AVEC_ARRET
unsigned int Phase_Arret = 50;	// Compteur de boucle : Autorise la mesure de la position du robot
								// pendant 200ms aprs l'arrt des moteurs devant la cible 
#endif
//============================================================================================================
 
//============================================================================================================
// INITIALISATIONS
//------------------------------------------------------------------------------------------------------------                                      
// Initialisation du mode Run: Chargement de la table PWM[][] avec les paramtres sauvegards en EEPROM
// i, k: compteur ligne, j compteur colonne    
// PWM_EEPROM[11,2] contient %Rapports cycliques -->  TABLE_CALCUL_OCRIx[21][2] --> PWM[11][2]
//------------------------------------------------------------------------------------------------------------
for (i=0;i<11;i++)  // La valeur de I dpend du nombre de capteurs utiliss
 { 
  for (j=0;j<2;j++)
   { 
    for (k=0;k<21;k++) // La valeur de k dpend du nombre de rglage PWM contenue dans la table
     {				   // Table_Calcul_OCR1x situe dans le fichier RB_Eleve.h
       if (PWM_EEPROM[i][j] == Table_Calcul_OCR1x[k][0])
       {   
	     PWM[i][j] = Table_Calcul_OCR1x[k][1];
	     break;
	   }
     }
   }
 }  
//------------------------------------------------------------------------------------------------------------  
// Global enable interrupts
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
// ATTENTION VOIR PROF: A dsactiver dans l'en tte du fichier RB_x_x_x.c en prcisant SANS_ARRET devant
// # define PARCOURS_ROBOT si la carte capteur cible n'est pas monte sur le robot 
//------------------------------------------------------------------------------------------------------------ 
#if PARCOURS_ROBOT == AVEC_ARRET
#asm("sei") 
#endif
//------------------------------------------------------------------------------------------------------------
// Fin initialisations
//============================================================================================================ 

//============================================================================================================
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! BOUCLE INFINIE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//------------------------------------------------------------------------------------------------------------
while (1)
    {// dbut Mode_Run() 
//============================================================================================================ 
// GESTION DE LA BALLE   
// ATTENTION VOIR PROF: A dsactiver dans l'en tte du fichier RB_x_x_x.c en prcisant SANS_ARRET devant
// # define PARCOURS_ROBOT si la carte capteur cible n'est pas monte sur le robot 
//------------------------------------------------------------------------------------------------------------
// Phase d'arrt devant la cible: Mesure de la position et volution du graphe "SUIVI DE LIGNE" pendant 
// [4.3*10E-3*Phase_Arret] puis lancement du sous-programme Prise_Balle()
//------------------------------------------------------------------------------------------------------------ 
#if PARCOURS_ROBOT == AVEC_ARRET
       if (Cible == 1) // Cible passe  1 lorsque le robot est devant la cible 
        {
          if (Phase_Arret == 0)
                Gestion_Balle(); // Cible <- dans INT0
                else 
                  Phase_Arret--;
        }  
#endif
//============================================================================================================     

/*============================================================================================================
// SUIVI DE LIGNE   
//============================================================================================================
//------------------------------------------------------------------------------------------------------------
// Dbut FS11: "Calculer la position du robot par rapport  la ligne" 		// !!!!! A COMPLETER PAR ELEVE
//------------------------------------------------------------------------------------------------------------          
Rle: Calculer une valeur numrique permettant de slectioner la LED IR (metteur IR) devant mettre
un faisceau infrarouge et calculer la valeur numrique reprsentative de la position du robot par
rapport  la ligne.

Entre: 	AC0		 		bit    		Associ  la sortie du comparateur analogique (interne au C). 
							   			Reprsentatif de la position d'un capteur IR par rapport  la ligne.

Sorties:    Cde_Del_IR 		octet   	Permet de multiplexer la commande des LED IR.
										Comme Cde_Del_IR est transfre dans le port A, on donne ci-dessous le
          								dtail des bits de commande des LED IR.
                                                
					   					Emetteur IR connect  au bit      Remarque 
										----------------------------------------------------         
										E_D_IR		"      PA0    |   Emetteur IR droit
										E_CD_IR     "      PA1    |   Emetteur IR centre droit
										E_C_IR		"      PA2    |	  Emetteur IR centre
										E_CG_IR     "	   PA3	  |   Emetteur IR centre Gauche
										E_G_IR 		"      PA4    |	  Emetteur IR gauche 
					                                                
			Position_Robot	octet 		Image de la position du robot par rapport  la ligne
										(dtails dans RBELEVE.h)

------------------------------------------------------------------------------------------------------------*/ 
      Position_Robot = HORS_LIGNE; // Initialisation  0	
      Cde_Del_IR = 1; 
 
      for (i=0;i<5;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
       {
        CAPTEUR_IR = ~Cde_Del_IR;
      	delay_us(30);	// Activation d'un capteur  ajuster   (19s par dfaut)
        if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;
        CAPTEUR_IR = 0xFF;
        Cde_Del_IR = Cde_Del_IR << 1 ;
        delay_us(540);	//  ajuster   (540s par dfaut)
       } 
// Fin FS11
//------------------------------------------------------------------------------------------------------------ 

                 
/*------------------------------------------------------------------------------------------------------------
// Dbut FS13 "Choisir la valeur  afficher sur les LEDs"				   		// !!!!! A COMPLETER PAR ELEVE
//------------------------------------------------------------------------------------------------------------ 
Rle: Choisir la valeur numrique ncessaire  la commande des LED rouge pour que leur clairage soit 
reprsentatif de la position du robot par rapport  la ligne noire.

Entre 
Position_Robot: octet 	Reprsentatif de la position du robot. Les deux positions possibles sont traites dans
						RBELEVE.h (Connecteur du capteur vers l'avant ou connecteur du capteur vers l'arrire).

Sortie
VisuPosition:  octet  	Reprsentatif des LED  clairer. Le bit 0 de VisuPosition commande la Led D0 de 
						l'interface IHM etc. Les valeurs  placer dans VisuPosition sont dfinies 
						dans le fichier RBELEVE.h
------------------------------------------------------------------------------------------------------------*/                 
switch (Position_Robot)              
       { 
// 		Position_Robot 			Modification de la valeur de commande des Leds       				
//------------------------------------------------------------------------------------------------------------
		case HORS_LIGNE:  		VisuPosition = Visu_Hors_ligne; break;			// Hors ligne
   		case GAUCHE_3PLUS:  	VisuPosition = Visu_GAUCHE_3PLUS; break;		// Gauche3+
  		case GAUCHE_2PLUS:  	VisuPosition = Visu_GAUCHE_2PLUS; break;		// Gauche2+
   		case CENTRE_1:     		VisuPosition = Visu_CENTRE_1; break;			// Centre1 non visualis
        case GAUCHE_PLUS:  		VisuPosition = Visu_GAUCHE_PLUS; break;			// Gauche+  
        case CENTRE_3: 	   		VisuPosition = Visu_CENTRE_3; break;			// Centre3 
        case GAUCHE: 			VisuPosition = Visu_GAUCHE; break;				// Gauche 
        case DROITE_3PLUS: 		VisuPosition = Visu_DROITE_3PLUS; break;		// Droite3+
        case DROITE_2PLUS: 		VisuPosition = Visu_DROITE_2PLUS; break;		// Droite2+  
        case DROITE_PLUS:  		VisuPosition = Visu_DROITE_PLUS; break;			// Droite+ 
        case DROITE: 	   		VisuPosition = Visu_DROITE; break;				// Droite 
        case CENTRE_5: 			VisuPosition = Visu_CENTRE_5; break;			// Centre5   
        default :				VisuPosition = 0b00011111; break;				// Visu_Erreur_mesure_ligne
       }     
       
		Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuPosition);  		// Ecriture sur les LED via le bus I2C     
// Fin FS13   
//------------------------------------------------------------------------------------------------------------
    

/*------------------------------------------------------------------------------------------------------------ 
// Dbut FS12: "Choisir les valeurs des rapports cycliques"					// !!!!!! A COMPLETER PAR ELEVE
//------------------------------------------------------------------------------------------------------------     
Rle: Choisir la valeur du rapport cyclique du signal de commande des moteurs du robot en fonction de
sa position par rapport  la ligne noire.

Entre:          Position_Robot           octet     (voir ci-dessus)    

Sorties:         CDE_MOTD                 octet		Correspond au registre (OCR1A). Rgle le rapport cyclique 
													du signal de commande du moteur droit.
				 CDE_MOTG                 octet     Correspond au registre (OCR1B). Rgle le rapport cyclique
				 							 		du signal de commande du moteur gauche.
------------------------------------------------------------------------------------------------------------*/ 
// Graphe d'tat du suivi de ligne
//------------------------------------------------------------------------------------------------------------
// Dpart
      switch (EtatCdeMot)              
       { // Dbut switch (EtatCdeMot)                                 
        case DEPART: Arret_Moteurs(); 
        		if ((Position_Robot == CENTRE_1)||(Position_Robot == CENTRE_3)||(Position_Robot == CENTRE_5))
        		    { 
        		      Active_Moteurs();
        		      EtatCdeMot = CDE_CENTRE;
        		    }
        		    else  EtatCdeMot = DEPART;
        break;   
//------------------------------------------------------------------------------------------------------------
// Suivi de ligne        
        case CDE_CENTRE : CDE_MOTG = PWM[0][0]; CDE_MOTD = PWM[0][1];
                          if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
                          	else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
                          		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
                          			else EtatCdeMot = CDE_CENTRE;
        break;  
        
        
        case CDE_DROITE:CDE_MOTG = PWM[1][0]; CDE_MOTD = PWM[1][1]; 
                         if (Position_Robot == CENTRE_5 ) EtatCdeMot = CDE_CENTRE;
                          	else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
                           		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
                          			else EtatCdeMot = CDE_DROITE;
        break;   
        
        case CDE_DROITE_PLUS:CDE_MOTG = PWM[2][0]; CDE_MOTD = PWM[2][1];
        		if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
                             else if (Position_Robot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS;
                        		else EtatCdeMot = CDE_DROITE_PLUS;
        break;  
        
        case CDE_DROITE_2PLUS: CDE_MOTG = PWM[3][0]; CDE_MOTD = PWM[3][1];
        		if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS; 
        	       		else if (Position_Robot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
        			   		else EtatCdeMot = CDE_DROITE_2PLUS;
        break;
             
        case CDE_DROITE_3PLUS: CDE_MOTG = PWM[4][0]; CDE_MOTD = PWM[4][1];
        		if (Position_Robot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS; 
        	       		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_HORS_LIGNE_DROITE;
        					else EtatCdeMot = CDE_DROITE_3PLUS;
        break;
        
        case CDE_HORS_LIGNE_DROITE : CDE_MOTG = PWM[5][0]; CDE_MOTD = PWM[5][1];
        		if (Position_Robot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
        				else EtatCdeMot = CDE_HORS_LIGNE_DROITE;
        break;
        			  			  
        case CDE_GAUCHE: CDE_MOTG = PWM[6][0]; CDE_MOTD = PWM[6][1]; 
                       if (Position_Robot == CENTRE_5) EtatCdeMot = CDE_CENTRE;
                          	else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;  
                          		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
                          			else EtatCdeMot = CDE_GAUCHE;
        break;  
        
        case CDE_GAUCHE_PLUS: CDE_MOTG = PWM[7][0]; CDE_MOTD = PWM[7][1]; 
                      if  (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
        	              else if (Position_Robot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
                               		else EtatCdeMot = CDE_GAUCHE_PLUS;
        break; 
        
        case CDE_GAUCHE_2PLUS: CDE_MOTG = PWM[8][0]; CDE_MOTD = PWM[8][1];
        		if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
        		        else if (Position_Robot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
        					else EtatCdeMot = CDE_GAUCHE_2PLUS;
        break;
        
        case CDE_GAUCHE_3PLUS: CDE_MOTG = PWM[9][0]; CDE_MOTD = PWM[9][1];
        		if (Position_Robot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
        	       		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_HORS_LIGNE_GAUCHE; 
        					else EtatCdeMot = CDE_GAUCHE_3PLUS;
        break;
        
        case CDE_HORS_LIGNE_GAUCHE: CDE_MOTG = PWM[10][0]; CDE_MOTD = PWM[10][1];
        		if (Position_Robot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
        				else EtatCdeMot = CDE_HORS_LIGNE_GAUCHE;
        break;
        
        case CDE_COUPURE: CDE_MOTG = PWM[0][0]; CDE_MOTD = PWM[0][1];
                          switch(Position_Robot)
                          {
                            case CENTRE_5:  EtatCdeMot = CDE_CENTRE; break;   
                            case GAUCHE:   EtatCdeMot = CDE_DROITE; break;
                            case GAUCHE_PLUS:   EtatCdeMot = CDE_DROITE_PLUS; break;
                            case GAUCHE_2PLUS:   EtatCdeMot = CDE_DROITE_2PLUS; break;
                            case GAUCHE_3PLUS:   EtatCdeMot = CDE_DROITE_3PLUS; break;
                            case DROITE:   EtatCdeMot = CDE_GAUCHE ; break;
                            case DROITE_PLUS:   EtatCdeMot = CDE_GAUCHE_PLUS; break;
                            case DROITE_2PLUS:   EtatCdeMot = CDE_GAUCHE_2PLUS; break;
                            case DROITE_3PLUS:   EtatCdeMot = CDE_GAUCHE_3PLUS; break;
                            default: EtatCdeMot = CDE_COUPURE; break;  
                          }
        
        break;
        
        default : EtatCdeMot = CDE_CENTRE; 
        break;
        
// Fin FS12 
//------------------------------------------------------------------------------------------------------------        
       }// Fin switch (EtatCdeMot)        
//------------------------------------------------------------------------------------------------------------
   
// Fin Traiter 
//============================================================================================================
       delay_us(2000); //  ajuster   (704s  par dfaut) 
//============================================================================================================		
    }
} // fin Mode_Run();
//============================================================================================================   

//============================================================================================================ 
//============================================================================================================
// *************************** SOUS-PROGRAMME GESTION DE LA BALLE ELEVE **************************************
//============================================================================================================
//============================================================================================================
#if PARCOURS_ROBOT == AVEC_ARRET
void Gestion_Balle(void)
{
// Dsactivation de la dtection de la cible
Cible = 0; 
//---------------------------------------------------------
// A complter par lve
//---------------------------------------------------------
//
CDE_SERVO1 = 1; // Libration balle
delay_ms(300);
CDE_SERVO1 = 0; // Arrt dclenchement 
CDE_SERVO2 = 1;  
delay_ms(1500);
//---------------------------------------------------------
// Marche Robot 
//---------------------------------------------------------
Active_Moteurs();  
//---------------------------------------------------------
}
#endif
//============================================================================================================
//============================================================================================================
