//============================================================================================================
//============================================================================================================
// ******************************** SOUS-PROGRAMME SUIVI DE LIGNE ELEVE **************************************
//============================================================================================================
//============================================================================================================
// 	Mode_Run() : LE ROBOT EFFECTUE SON PARCOURS
//------------------------------------------------------------------------------------------------------------
// !!!!!!!!! Attention : on sort du menu Mode_Run par une coupure d'alimentation !!!!!!!!
//============================================================================================================
void Mode_Run()
{
//------------------------------------------------------------------------------------------------------------ 
// Variables locale  Mode_Run()  
//------------------------------------------------------------------------------------------------------------
// type			nom						Commentaires
//------------------------------------------------------------------------------------------------------------ 
unsigned char i,j,k;            // Compteurs des boucles utilises pour transfrer en RAM, les valeurs 
								// correspondant aux %rapports cycliques sauvegardes dans l'eeprom
unsigned char VisuPosition;		// Contient la valeur transmise aux Leds pendant le dplacement 
unsigned char PWM[11][2];		// Contient les coefficients destins au Timers(PWM) pour le rglage de la 
								// frquence de rotation des moteurs. 
unsigned char Cde_Del_IR;		// Permet de multiplexer la commande des Leds des capteurs IR

#if PARCOURS_ROBOT == AVEC_ARRET
unsigned int Phase_Arret = 50;	// Compteur de boucle : Autorise la mesure de la position du robot
								// pendant 200ms aprs l'arrt des moteurs devant la cible 
#endif
//============================================================================================================
 
//============================================================================================================
// INITIALISATIONS
//------------------------------------------------------------------------------------------------------------                                      
// Initialisation du mode Run: Chargement de la table PWM[][] avec les paramtres sauvegards en EEPROM
// i, k: compteur ligne, j compteur colonne    
// PWM_EEPROM[11,2] contient %Rapports cycliques -->  TABLE_CALCUL_OCRIx[21][2] --> PWM[11][2]
//------------------------------------------------------------------------------------------------------------
for (i=0;i<11;i++)  // La valeur de I dpend du nombre de capteurs utiliss
 { 
  for (j=0;j<2;j++)
   { 
    for (k=0;k<21;k++) // La valeur de k dpend du nombre de rglage PWM contenue dans la table
     {				   // Table_Calcul_OCR1x situe dans le fichier RB_Eleve.h
       if (PWM_EEPROM[i][j] == Table_Calcul_OCR1x[k][0])
       {   
	     PWM[i][j] = Table_Calcul_OCR1x[k][1];
	     break;
	   }
     }
   }
 }  
//------------------------------------------------------------------------------------------------------------  
// Global enable interrupts
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
// ATTENTION VOIR PROF: A dsactiver dans l'en tte du fichier RB_x_x_x.c en prcisant SANS_ARRET devant
// # define PARCOURS_ROBOT si la carte capteur cible n'est pas monte sur le robot 
//------------------------------------------------------------------------------------------------------------ 
#if PARCOURS_ROBOT == AVEC_ARRET
#asm("sei") 
#endif
//------------------------------------------------------------------------------------------------------------
// Fin initialisations
//============================================================================================================ 

//============================================================================================================
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! BOUCLE INFINIE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//------------------------------------------------------------------------------------------------------------
while (1)
    {// dbut Mode_Run() 
//============================================================================================================ 
// GESTION DE LA BALLE   
// ATTENTION VOIR PROF: A dsactiver dans l'en tte du fichier RB_x_x_x.c en prcisant SANS_ARRET devant
// # define PARCOURS_ROBOT si la carte capteur cible n'est pas monte sur le robot 
//------------------------------------------------------------------------------------------------------------
// Phase d'arrt devant la cible: Mesure de la position et volution du graphe "SUIVI DE LIGNE" pendant 
// [4.3*10E-3*Phase_Arret] puis lancement du sous-programme Prise_Balle()
//------------------------------------------------------------------------------------------------------------ 
#if PARCOURS_ROBOT == AVEC_ARRET
       if (Cible == 1) // Cible passe  1 lorsque le robot est devant la cible 
        {
          if (Phase_Arret == 0)
                Gestion_Balle(); // Cible <- dans INT0
                else 
                  Phase_Arret--;
        }  
#endif
//============================================================================================================     

/*============================================================================================================
// SUIVI DE LIGNE   
//============================================================================================================
//------------------------------------------------------------------------------------------------------------
// Dbut FS11: "Calculer la position du robot par rapport  la ligne" 		// !!!!! A COMPLETER PAR ELEVE
//------------------------------------------------------------------------------------------------------------          
Rle: Calculer une valeur numrique permettant de slectioner la LED IR (metteur IR) devant mettre
un faisceau infrarouge et calculer la valeur numrique reprsentative de la position du robot par
rapport  la ligne.

Entre: 	AC0		 		bit    		Associ  la sortie du comparateur analogique (interne au C). 
							   			Reprsentatif de la position d'un capteur IR par rapport  la ligne.

Sorties:    Cde_Del_IR 		octet   	Permet de multiplexer la commande des LED IR.
										Comme Cde_Del_IR est transfre dans le port A, on donne ci-dessous le
          								dtail des bits de commande des LED IR.
                                                
					   					Emetteur IR connect  au bit      Remarque 
										----------------------------------------------------         
										E_D_IR		"      PA0    |   Emetteur IR droit
										E_CD_IR     "      PA1    |   Emetteur IR centre droit
										E_C_IR		"      PA2    |	  Emetteur IR centre
										E_CG_IR     "	   PA3	  |   Emetteur IR centre Gauche
										E_G_IR 		"      PA4    |	  Emetteur IR gauche 
					                                                
			Position_Robot	octet 		Image de la position du robot par rapport  la ligne
										(dtails dans RBELEVE.h)

------------------------------------------------------------------------------------------------------------*/ 
      Position_Robot = HORS_LIGNE; // Initialisation  0	
      Cde_Del_IR = 1; 
 
      for (i=0;i<5;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
       {
        CAPTEUR_IR = ~Cde_Del_IR;
      	delay_us(30);	// Activation d'un capteur  ajuster   (19s par dfaut)
        if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;
        CAPTEUR_IR = 0xFF;
        Cde_Del_IR = Cde_Del_IR << 1 ;
        delay_us(540);	//  ajuster   (540s par dfaut)
       } 
// Fin FS11
//------------------------------------------------------------------------------------------------------------ 

                 
/*------------------------------------------------------------------------------------------------------------
// Dbut FS13 "Choisir la valeur  afficher sur les LEDs"				   		// !!!!! A COMPLETER PAR ELEVE
//------------------------------------------------------------------------------------------------------------ 
Rle: Choisir la valeur numrique ncessaire  la commande des LED rouge pour que leur clairage soit 
reprsentatif de la position du robot par rapport  la ligne noire.

Entre 
Position_Robot: octet 	Reprsentatif de la position du robot. Les deux positions possibles sont traites dans
						RBELEVE.h (Connecteur du capteur vers l'avant ou connecteur du capteur vers l'arrire).

Sortie
VisuPosition:  octet  	Reprsentatif des LED  clairer. Le bit 0 de VisuPosition commande la Led D0 de 
						l'interface IHM etc. Les valeurs  placer dans VisuPosition sont dfinies 
						dans le fichier RBELEVE.h
------------------------------------------------------------------------------------------------------------*/                 
switch (Position_Robot)              
       { 
// 		Position_Robot 			Modification de la valeur de commande des Leds       				
//------------------------------------------------------------------------------------------------------------
		case HORS_LIGNE:  		VisuPosition = Visu_Hors_ligne; break;			// Hors ligne
   		case GAUCHE_3PLUS:  	VisuPosition = Visu_GAUCHE_3PLUS; break;		// Gauche3+
  		case GAUCHE_2PLUS:  	VisuPosition = Visu_GAUCHE_2PLUS; break;		// Gauche2+
   		case CENTRE_1:     		VisuPosition = Visu_CENTRE_1; break;			// Centre1 non visualis
        case GAUCHE_PLUS:  		VisuPosition = Visu_GAUCHE_PLUS; break;			// Gauche+  
        case CENTRE_3: 	   		VisuPosition = Visu_CENTRE_3; break;			// Centre3 
        case GAUCHE: 			VisuPosition = Visu_GAUCHE; break;				// Gauche 
        case DROITE_3PLUS: 		VisuPosition = Visu_DROITE_3PLUS; break;		// Droite3+
        case DROITE_2PLUS: 		VisuPosition = Visu_DROITE_2PLUS; break;		// Droite2+  
        case DROITE_PLUS:  		VisuPosition = Visu_DROITE_PLUS; break;			// Droite+ 
        case DROITE: 	   		VisuPosition = Visu_DROITE; break;				// Droite 
        case CENTRE_5: 			VisuPosition = Visu_CENTRE_5; break;			// Centre5   
        default :				VisuPosition = 0b00011111; break;				// Visu_Erreur_mesure_ligne
       }     
       
		Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuPosition);  		// Ecriture sur les LED via le bus I2C     
// Fin FS13   
//------------------------------------------------------------------------------------------------------------
    

/*------------------------------------------------------------------------------------------------------------ 
// Dbut FS12: "Choisir les valeurs des rapports cycliques"					// !!!!!! A COMPLETER PAR ELEVE
//------------------------------------------------------------------------------------------------------------     
Rle: Choisir la valeur du rapport cyclique du signal de commande des moteurs du robot en fonction de
sa position par rapport  la ligne noire.

Entre:          Position_Robot           octet     (voir ci-dessus)    

Sorties:         CDE_MOTD                 octet		Correspond au registre (OCR1A). Rgle le rapport cyclique 
													du signal de commande du moteur droit.
				 CDE_MOTG                 octet     Correspond au registre (OCR1B). Rgle le rapport cyclique
				 							 		du signal de commande du moteur gauche.
------------------------------------------------------------------------------------------------------------*/ 
// Graphe d'tat du suivi de ligne
//------------------------------------------------------------------------------------------------------------
// Dpart
      switch (EtatCdeMot)              
       { // Dbut switch (EtatCdeMot)                                 
        case DEPART: Arret_Moteurs(); 
        		if ((Position_Robot == CENTRE_1)||(Position_Robot == CENTRE_3)||(Position_Robot == CENTRE_5))
        		    { 
        		      Active_Moteurs();
        		      EtatCdeMot = CDE_CENTRE;
        		    }
        		    else  EtatCdeMot = DEPART;
        break;   
//------------------------------------------------------------------------------------------------------------
// Suivi de ligne        
        case CDE_CENTRE : CDE_MOTG = PWM[0][0]; CDE_MOTD = PWM[0][1];
                          if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
                          	else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
                          		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
                          			else EtatCdeMot = CDE_CENTRE;
        break;  
        
        
        case CDE_DROITE:CDE_MOTG = PWM[1][0]; CDE_MOTD = PWM[1][1]; 
                         if (Position_Robot == CENTRE_5 ) EtatCdeMot = CDE_CENTRE;
                          	else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
                           		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
                          			else EtatCdeMot = CDE_DROITE;
        break;   
        
        case CDE_DROITE_PLUS:CDE_MOTG = PWM[2][0]; CDE_MOTD = PWM[2][1];
        		if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
                             else if (Position_Robot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS;
                        		else EtatCdeMot = CDE_DROITE_PLUS;
        break;  
        
        case CDE_DROITE_2PLUS: CDE_MOTG = PWM[3][0]; CDE_MOTD = PWM[3][1];
        		if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS; 
        	       		else if (Position_Robot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
        			   		else EtatCdeMot = CDE_DROITE_2PLUS;
        break;
             
        case CDE_DROITE_3PLUS: CDE_MOTG = PWM[4][0]; CDE_MOTD = PWM[4][1];
        		if (Position_Robot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS; 
        	       		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_HORS_LIGNE_DROITE;
        					else EtatCdeMot = CDE_DROITE_3PLUS;
        break;
        
        case CDE_HORS_LIGNE_DROITE : CDE_MOTG = PWM[5][0]; CDE_MOTD = PWM[5][1];
        		if (Position_Robot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
        				else EtatCdeMot = CDE_HORS_LIGNE_DROITE;
        break;
        			  			  
        case CDE_GAUCHE: CDE_MOTG = PWM[6][0]; CDE_MOTD = PWM[6][1]; 
                       if (Position_Robot == CENTRE_5) EtatCdeMot = CDE_CENTRE;
                          	else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;  
                          		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
                          			else EtatCdeMot = CDE_GAUCHE;
        break;  
        
        case CDE_GAUCHE_PLUS: CDE_MOTG = PWM[7][0]; CDE_MOTD = PWM[7][1]; 
                      if  (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
        	              else if (Position_Robot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
                               		else EtatCdeMot = CDE_GAUCHE_PLUS;
        break; 
        
        case CDE_GAUCHE_2PLUS: CDE_MOTG = PWM[8][0]; CDE_MOTD = PWM[8][1];
        		if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
        		        else if (Position_Robot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
        					else EtatCdeMot = CDE_GAUCHE_2PLUS;
        break;
        
        case CDE_GAUCHE_3PLUS: CDE_MOTG = PWM[9][0]; CDE_MOTD = PWM[9][1];
        		if (Position_Robot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
        	       		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_HORS_LIGNE_GAUCHE; 
        					else EtatCdeMot = CDE_GAUCHE_3PLUS;
        break;
        
        case CDE_HORS_LIGNE_GAUCHE: CDE_MOTG = PWM[10][0]; CDE_MOTD = PWM[10][1];
        		if (Position_Robot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
        				else EtatCdeMot = CDE_HORS_LIGNE_GAUCHE;
        break;
        
        case CDE_COUPURE: CDE_MOTG = PWM[0][0]; CDE_MOTD = PWM[0][1];
                          switch(Position_Robot)
                          {
                            case CENTRE_5:  EtatCdeMot = CDE_CENTRE; break;   
                            case GAUCHE:   EtatCdeMot = CDE_DROITE; break;
                            case GAUCHE_PLUS:   EtatCdeMot = CDE_DROITE_PLUS; break;
                            case GAUCHE_2PLUS:   EtatCdeMot = CDE_DROITE_2PLUS; break;
                            case GAUCHE_3PLUS:   EtatCdeMot = CDE_DROITE_3PLUS; break;
                            case DROITE:   EtatCdeMot = CDE_GAUCHE ; break;
                            case DROITE_PLUS:   EtatCdeMot = CDE_GAUCHE_PLUS; break;
                            case DROITE_2PLUS:   EtatCdeMot = CDE_GAUCHE_2PLUS; break;
                            case DROITE_3PLUS:   EtatCdeMot = CDE_GAUCHE_3PLUS; break;
                            default: EtatCdeMot = CDE_COUPURE; break;  
                          }
        
        break;
        
        default : EtatCdeMot = CDE_CENTRE; 
        break;
        
// Fin FS12 
//------------------------------------------------------------------------------------------------------------        
       }// Fin switch (EtatCdeMot)        
//------------------------------------------------------------------------------------------------------------
   
// Fin Traiter 
//============================================================================================================
       delay_us(2000); //  ajuster   (704s  par dfaut) 
//============================================================================================================		
    }
} // fin Mode_Run();
//============================================================================================================   

//============================================================================================================ 
//============================================================================================================
// *************************** SOUS-PROGRAMME GESTION DE LA BALLE ELEVE **************************************
//============================================================================================================
//============================================================================================================
#if PARCOURS_ROBOT == AVEC_ARRET
void Gestion_Balle(void)
{
// Dsactivation de la dtection de la cible
Cible = 0; 
//---------------------------------------------------------
// A complter par lve
//---------------------------------------------------------
//
CDE_SERVO1 = 1; // Libration balle
delay_ms(300);
CDE_SERVO1 = 0; // Arrt dclenchement 
CDE_SERVO2 = 1;  
delay_ms(1500);
//---------------------------------------------------------
// Marche Robot 
//---------------------------------------------------------
Active_Moteurs();  
//---------------------------------------------------------
}
#endif
//============================================================================================================