/*-----------------------------------------------------------------------
Nom du fichier: RBELEVE.h
Auteur: Philippe MARIANO

Projet: Robot suiveur de ligne
Rle: Fichier d'en-tte  
Cr le: 18/02/2010
Dernire rvision le: 15/04/2010

Cross compilateur utilis: CodeVisionAVR
Composant cible : ATMEL 8 bits sur carte "Robot SISI"

Remarque: Ce fichier est destin  un projet CVAVR utilisant la carte SISI
Il doit tre plac dans le sous rpertoire \CVAVR\INC\ ou dans le rpertoire 
du projet 
------------------------------------------------------------------------*/


#ifndef _RBELEVE_INCLUDED_ 	
#define _RBELEVE_INCLUDED_ 



//============================================================================================================
// CONSTANTES
//------------------------------------------------------------------------------------------------------------
// Mots de commande des Leds visualisant la position du robot par rapport  la ligne  // A COMPLETER PAR ELEVE
// REMPLACER 0xFF signifiant : toutes les Leds teintes par la valeur correspondant  la position  visualiser
// ------------------------------------------------------------------------------------------------------------
#define Visu_Hors_ligne 	0b11111111
#define Visu_GAUCHE_3PLUS	0b11111110 
#define Visu_GAUCHE_2PLUS	0b11111100 
#define Visu_CENTRE_1		0b11111111
#define Visu_GAUCHE_PLUS    0b11111000
#define Visu_CENTRE_3       0b11111111
#define Visu_GAUCHE         0b11110000
#define Visu_DROITE_3PLUS	0b11101111
#define Visu_DROITE_2PLUS	0b11100111   
#define Visu_DROITE_PLUS    0b11100011    
#define Visu_DROITE			0b11100001
#define Visu_CENTRE_5		0b11100000
//============================================================================================================ 
    
// Table de transcodage %PWM --> valeur  placer dans OCR1x         												
//------------------------------------------------------------------------------------------------------------ 
/* Pour info: Rapports cycliques alpha du signal de commande des moteurs       // A retirer dans fichier lve
//------------------------------------------------------------------------------------------------------------ 
// ATTENTION, dans le cas prsent: OCR1x = 255*alpha  
//------------------------------------------------------------------------------------------------------------
// 				OCR1x		 	alpha 
#define _0PC	 0		 		// 0% 
#define _5PC	 13       		// 5% 
#define _10PC	 25             // 10%
#define _15PC	 38             // 15%
#define _20PC    51		 		// 20%
#define _25PC	 64             // 25%
#define _30PC    76		 		// 30%
#define _35PC	 89             // 35% 
#define _40PC    102		 	// 40%
#define _45PC	 115            // 45%
#define _50PC    128            // 50%
#define _55PC	 140            // 55% 
#define _60PC    153            // 60%
#define _65PC	 166            // 65%
#define _70PC    179            // 70%
#define _75PC	 191            // 75%
#define _80PC    205            // 80%     
#define _85PC    219            // 85% 
#define _90PC    233            // 90% 
#define _100%	 253			// ~100%
------------------------------------------------------------------------------------------------------------*/ 
// A complter par lve en fonction des rsultats de la fiche guide FG4 + les valeurs x5%  (1< x <9)
const unsigned char Table_Calcul_OCR1x[21][2]={{0,0},{5,13},{10,25},{15,38},{20,51},{25,64},{30,76},
{35,89},{40,102},{45,115},{50,128},{55,140},{60,153},{65,166},{70,179},{75,191},{80,205},{85,219},
{90,233},{95,233},{100,253}}; 	
//============================================================================================================

//============================================================================================================
// VARIABLES
//------------------------------------------------------------------------------------------------------------
/* Etat_Position_Robot: numration des valeurs reprsentatives des positions du robot par rapport  la ligne 
//------------------------------------------------------------------------------------------------------------
Infos: Dans l'numration ci-dessous, la valeur affecte au NOM d'une position dpend du sens de la 
carte "Capteur Ligne" et de son cblage au port x. Une cellule IR sur la ligne => bit correspondant = 1. 
Une cellule IR hors ligne => bit correspondant = 0  
																	 	^^
				     												 	||  sens du dplacement du robot
Exemple: module "Capteur" de ligne compos de 5 cellules IR Ux: 	U5 U4 U3 U2 U1  posit. des capteurs
	Avec 	U1 reli  PA0
     		U2 reli  PA1
     		U3 reli  PA2
     		U4 reli  PA3
     		U5 reli  PA4

Si U4 et U5 sont hors ligne, le robot a la position note GAUCHE_PLUS. La valeur renvoye
par le capteur est PAO = 1, PA1 = 1, PA2 = 1, PA3 = 0 et PA4 = 0 donc GAUCHE_PLUS = 4+2+1 = 7     		
------------------------------------------------------------------------------------------------------------*/
// Pour un capteur dont le connecteur est plac vers l'avant du robot, la table des valeurs est:
//------------------------------------------------------------------------------------------------------------ 
// Position_Robot  		Correspond  :                                                         
// 		0	   				Hors_Ligne          
// 		1					Gauche3+            
// 		3 					Gauche2+
//		4					Centre1 (1 capteur IR sur la ligne) 	
// 		7					Gauche+ 
//		14					Centre3 (3 capteurs IR sur la ligne)
//		15					Gauche
//		16					Droite3+
//		24					Droite2+			
//		28					Droite+ 
//		30					Droite
// 		31 					Centre5 (5 capteurs IR sur la ligne) 
//------------------------------------------------------------------------------------------------------------ 
// Cette table est sauvegarde sous la forme d'une numration !
 
// Les valeurs ci-dessous sont reprsentatives d'un capteur positionn avec le connecteur  l'AVANT
// par rapport au sens du dplacement  
#if  POSITIONCONNECTEUR == CONNECTEURAV
enum Etat_Position_Robot {HORS_LIGNE, GAUCHE_3PLUS, GAUCHE_2PLUS = 3, CENTRE_1, GAUCHE_PLUS=7, 
CENTRE_3=14, GAUCHE, DROITE_3PLUS, DROITE_2PLUS=24, DROITE_PLUS=28, DROITE = 30,CENTRE_5} 
Position_Robot = HORS_LIGNE, Position_Robot_1 = GAUCHE_3PLUS;    
//------------------------------------------------------------------------------------------------------------
// Les valeurs ci-dessous sont reprsentatives d'un capteur positionn avec le connecteur  l'ARRIERE
// par rapport au sens du dplacement 
#elif POSITIONCONNECTEUR == CONNECTEURAR
enum Etat_Position_Robot {HORS_LIGNE, DROITE_3PLUS, DROITE_2PLUS = 3, CENTRE_1, DROITE_PLUS=7, 
CENTRE_3=14, DROITE, GAUCHE_3PLUS, GAUCHE_2PLUS=24, GAUCHE_PLUS=28, GAUCHE = 30,CENTRE_5} 
Position_Robot = HORS_LIGNE, Position_Robot_1 = GAUCHE_3PLUS;  
#endif
//============================================================================================================

#endif