;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega32L
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 512 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : No
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "RB_2_1_2.vec"
	.INCLUDE "RB_2_1_2.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x260
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE robot suiveur de ligne 
;      10 Version : 2.1.2a
;      11 Date de cration   : 19/03/2008
;      12 Dernire mise  jour : 24/04/2010
;      13 Author  : Mariano philippe et lves de TS SI                           
;      14 Company : Lyce Pierre Emile Martin
;      15 1, Avenue de Gionne 18000 BOURGES   
;      16 --------------------------------------------------------                             
;      17 Comments:  
;      18 Les LED et le clavier sont commands par I2C soft.
;      19 A l'arrt: Modification des paramtres PWM sur le robot,
;      20 test des servos, test des moteurs, test du capteur ligne
;      21 et test du capteur constitu de 5 cellules infrarouge.
;      22 En dplacement: Affichage de la position du robot par 
;      23 rapport  la ligne sur les cinq LED de droite.
;      24 Affichage Erreur de mesure sur les trois LED de gauche
;      25 Arrt devant la cible et tir (compilation conditionnelle)  
;      26 --------------------------------------------------------
;      27 Chip type           : ATmega8535 ou ATMEGA32
;      28 Program type        : Application
;      29 Clock frequency     : 8,000000 MHz
;      30 Memory model        : Small
;      31 External SRAM size  : 0
;      32 Data Stack size     : 128
;      33 ********************************************************/
;      34 
;      35 //============================================================================================================  
;      36 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;      37 // ATTENTION : Fichier principal du projet (Ne pas modifier sans l'avis du prof)  
;      38 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;      39 //============================================================================================================
;      40 
;      41 //============================================================================================================
;      42 // INFORMATIONS et DECLARATIONS pour la compilation conditionnelle
;      43 //------------------------------------------------------------------------------------------------------------
;      44 // Les paramtres  rgler avant de compiler sont:
;      45 // - 1 La position de la carte "capteur ligne" (Choix: CONNECTEURAR ou CONNECTEURAV)
;      46 // - 2 Le microcontrleur cibl (Choix: 	ATMEGA8535 ou ATMEGA32)    
;      47 // - 3 La gestion de l'arrt devant la cible (Choix: AVEC_ARRET ou SANS_ARRET)
;      48 //------------------------------------------------------------------------------------------------------------
;      49 // 1 Position de la carte "capteur ligne" 
;      50 // La position de la carte "Capteur Ligne" sur le robot conditionne les valeurs  attribuer aux constantes dans 
;      51 // l'numration "Etat_Position_Robot" (voir fichier RB_ELEVE.h)
;      52 // Le cas ou le connecteur est orient vers l'avant est slectionn par CONNECTEURAV 
;      53 // Le cas ou le connecteur est orient vers l'arrire est slectionn par CONNECTEURAR
;      54 #define CONNECTEURAV 	0
;      55 #define CONNECTEURAR	1
;      56 //------------------------------------------------------------------------------------------------------------
;      57 // 2 Microcontrleurs cibls 
;      58 #define ATMEGA8535 		1
;      59 #define ATMEGA32		2  
;      60 //------------------------------------------------------------------------------------------------------------
;      61 // 3 Gestion de l'arrt devant la cible 
;      62 #define SANS_ARRET		0
;      63 #define AVEC_ARRET		1 
;      64 //------------------------------------------------------------------------------------------------------------
;      65 //------------------------------------------------------------------------------------------------------------
;      66 // !!!!!!!!!!!!!!!!!! ATTENTION : PARAMETRAGE de la COMPILATION CI-DESSOUS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
;      67 //------------------------------------------------------------------------------------------------------------
;      68 // Choisir ici le composant cibl par la compilation: 	ATMEGA8535 ou ATMEGA32
;      69 #define CIBLE						ATMEGA32
;      70 // Choisir ici la position de la carte "capteur ligne": CONNECTEURAR ou CONNECTEURAV
;      71 #define POSITIONCONNECTEUR			CONNECTEURAR        
;      72 // Choisir ici l'arrt devant la cible: AVEC_ARRET ou SANS_ARRET 
;      73 #define PARCOURS_ROBOT				AVEC_ARRET
;      74 //============================================================================================================
;      75 
;      76 //============================================================================================================
;      77 // Bibliothques   
;      78 //------------------------------------------------------------------------------------------------------------ 
;      79 // CVAVR
;      80 //------------------------------------------------------------------------------------------------------------
;      81 #if CIBLE == ATMEGA8535 
;      82 #include <mega8535.h> 
;      83 #elif  CIBLE == ATMEGA32
;      84 #include <mega32.h>
;      85 #endif
;      86 
;      87 #include <delay.h>
;      88 #include <stdio.h>       
;      89 #include <stdlib.h>
;      90 #include <string.h>
;      91 #include <math.h>
;      92 //------------------------------------------------------------------------------------------------------------
;      93 // Bibliothques dveloppes pour la carte SISI
;      94 //------------------------------------------------------------------------------------------------------------							
;      95 #include "sisisvl.h"  		// Lire_BP_I2C_Soft, Affiche_LCD, Arret_Moteurs, Active_Moteurs, Affiche_Fleche 
;      96 #include "PCF8574.h"        // Ecrire_Port_I2C_Soft, Lire_Port_I2C_Soft  
;      97 #include "RBELEVE.h"        // Paramtres du capteur ligne et paramtres de commande des moteurs

	.CSEG

	.DSEG
;      98 //============================================================================================================
;      99 
;     100 //============================================================================================================
;     101 // Dclarations  
;     102 //------------------------------------------------------------------------------------------------------------
;     103 // I2C Bus functions
;     104 #asm
;     105    .equ __i2c_port=0x18
   .equ __i2c_port=0x18
;     106    .equ __sda_bit=1
   .equ __sda_bit=1
;     107    .equ __scl_bit=0
   .equ __scl_bit=0
;     108 #endasm

;     109 #include <i2c.h>
;     110 
;     111 // Alphanumeric LCD Module functions   
;     112 #asm
;     113    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;     114 #endasm

;     115 #include <lcd.h>  
;     116 //============================================================================================================
;     117 
;     118 //============================================================================================================
;     119 // CONSTANTES
;     120 //------------------------------------------------------------------------------------------------------------
;     121 // Constantes en eeprom
;     122 //------------------------------------------------------------------------------------------------------------
;     123 /// Table des valeurs de rglage des signaux PWM en eeprom  ( initialiser avec le fichier EEPROMROBOTBASE.eep 
;     124 // lors de la premire mise en oeuvre du robot (Voir prof)
;     125 //------------------------------------------------------------------------------------------------------------ 
;     126 eeprom unsigned char PWM_EEPROM[11][2];

	.ESEG
_PWM_EEPROM:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;     127 // Organisation de la table	PWM_EEPROM[11][2]  
;     128 //	Position	 MG    MD
;     129 //   n          [n,0] [n,1]
;     130 // Centre       val00  val01
;     131 // Droite
;     132 // Droite+
;     133 // Droite2+
;     134 // Droite3+
;     135 // HorsLigneD
;     136 // Gauche
;     137 // Gauche+
;     138 // Gauche2+
;     139 // Gauche3+
;     140 // HorsLigneG
;     141 //------------------------------------------------------------------------------------------------------------
;     142 // Constantes en flash
;     143 //------------------------------------------------------------------------------------------------------------
;     144 // Tables des caractres personnaliss:  placer dans la mmoire CGRAM du LCD  
;     145 //------------------------------------------------------------------------------------------------------------
;     146 const unsigned char flecheHaut[] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};    // @1 CGRAM

	.CSEG
;     147 const unsigned char flecheBas[] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};     // @2 CGRAM
;     148 //============================================================================================================
;     149 
;     150 
;     151 //============================================================================================================
;     152 // Variables globales
;     153 //------------------------------------------------------------------------------------------------------------ 
;     154 // type		   	   		nom						   				Commentaires
;     155 //------------------------------------------------------------------------------------------------------------
;     156 // Tableau des structures des menus "Rglage des paramtres PWM"  
;     157 //------------------------------------------------------------------------------------------------------------
;     158 flash struct Affichage_reglages {
;     159 		char ligne0[14]; // 12 caractres + fin de ligne arrondi  l'entier pair suprieur
;     160 		char ligne1[14]; // Ligne0 = 1er ligne de l'affichage 
;     161 		} Tab_Aff_Reg[11]= {{"Centre MG  =","Centre MD  ="},
;     162 				    {"Droite MG  =","Droite MD  ="},
;     163 				    {"Droite+ MG =","Droite+ MD ="},
;     164 				    {"Droite2+ MG=","Droite2+ MD="},
;     165 				    {"Droite3+ MG=","Droite3+ MD="},
;     166 				    {"HorLigD MG =","HorLigD MD ="},
;     167 				    {"Gauche MG  =","Gauche MD  ="},
;     168 				    {"Gauche+ MG =","Gauche+ MD ="},
;     169 				    {"Gauche2+ MG=","Gauche2+ MD="},
;     170 				    {"Gauche3+ MG=","Gauche3+ MD="},
;     171 				    {"HorLigG MG =","HorLigG MD ="}};
;     172 //------------------------------------------------------------------------------------------------------------ 
;     173 // Etats du graphe des transitions des menus                        				
;     174 //------------------------------------------------------------------------------------------------------------
;     175 enum TMenu {Menu_Reglages, Menu_Run, Menu_Tests, Menu_Test_Servos, Menu_Test_Moteurs, Cde_Moteurs,  
;     176        Reglage_PWM, Activation, Menu_Test_Capteurs_Ligne, Menu_Test_Capteurs_Cible, Affiche_Reglages, Cde_Servo,
;     177        Visu_Position,Visu_Cible  } Menu=Menu_Reglages, Menu_1=Menu_Run; // Etats du graphe tests          

	.DSEG
;     178 //------------------------------------------------------------------------------------------------------------
;     179 // Diffrentes commandes des moteurs 											
;     180 //------------------------------------------------------------------------------------------------------------
;     181 enum Etat_Commande_Moteur {DEPART,CDE_CENTRE, CDE_CENTRE2, CDE_CENTRE3, CDE_DROITE, CDE_DROITE_PLUS, 
;     182 CDE_DROITE_2PLUS, CDE_DROITE_3PLUS, CDE_GAUCHE, CDE_GAUCHE_PLUS, CDE_GAUCHE_2PLUS, CDE_GAUCHE_3PLUS,
;     183 CDE_HORS_LIGNE_GAUCHE, CDE_HORS_LIGNE_DROITE, CDE_COUPURE } EtatCdeMot = DEPART;
;     184 //------------------------------------------------------------------------------------------------------------ 
;     185 //------------------------------------------------------------------------------------------------------------
;     186 // Pour la dtection de la cible (utilis dans INT0, dans le menu VisuCible et par le SP Mode_RUN) 
;     187 //------------------------------------------------------------------------------------------------------------
;     188 bit Cible=0;         // cible = 0 => pas de dtection, cible = 1 => dtection 
;     189 #if PARCOURS_ROBOT == AVEC_ARRET 
;     190 bit Cible_1 = 1;     
;     191 #endif
;     192 //============================================================================================================
;     193 
;     194 //============================================================================================================
;     195 // Prototype des fonctions places  la fin du fichier 
;     196 //------------------------------------------------------------------------------------------------------------ 
;     197 // Ces sous programmes se situent dans le fichier RB_ELEVE.c que les lves doivent complter 
;     198 void Mode_Run(void);        	// SP Suivi de ligne  
;     199 #if PARCOURS_ROBOT == AVEC_ARRET  
;     200 void Gestion_Balle(void);		// SP Gestion de la balle
;     201 #endif
;     202 //============================================================================================================
;     203 
;     204 
;     205 //============================================================================================================
;     206 // Sous programme d'interruption dclench sur un front descendant de INT0 
;     207 // (Dtection de la cible par un contact reed ferm par la prsence d'un aimant)
;     208 //------------------------------------------------------------------------------------------------------------
;     209 // External Interrupt 0 service routine
;     210 interrupt [EXT_INT0] void ext_int0_isr(void)
;     211 {

	.CSEG
_ext_int0_isr:
	CALL __SAVEISR
;     212 // Dsactivation de l'INT0
;     213 GICR=0x00; // Dsactivation INT0 (bit6 de GICR)
	CLR  R30
	OUT  0x3B,R30
;     214 Arret_Moteurs();  // Arrt du robot
	CALL _Arret_Moteurs
;     215 Cible = 1; 
	SET
	BLD  R2,0
;     216 }
	CALL __LOADISR
	RETI
;     217 //============================================================================================================  
;     218 
;     219 //============================================================================================================  
;     220 //============================================================================================================
;     221 // Programme principal
;     222 //============================================================================================================
;     223 //============================================================================================================
;     224 void main(void)
;     225 { // Dbut du main
_main:
;     226 //============================================================================================================
;     227 // Variables locales  la fonction principale 
;     228 //------------------------------------------------------------------------------------------------------------
;     229 // type	   			nom			   					Commentaires
;     230 //------------------------------------------------------------------------------------------------------------
;     231 unsigned char BP,Code_BP;						// Etat des boutons-poussoirs de la carte SISI
;     232 unsigned char i;                        		// Compteur d'usage gnral
;     233 unsigned char NumServo=1, NumServo_1=1;			// Saisie du numro du servo
;     234 unsigned char Aff_Cde_Servo=0, Aff_Cde_Servo_1=0; 	// Valeur  envoyer au servo slectionn dans le menu Cde_Servo  
;     235 unsigned char decompte=5, decompte_1=5;			// Temporisation avant le passage en mode RUN
;     236 int i_n=0, i_n_1=1; 							// Indices du tableau des structures d'affichage 
;     237 char display_buffer_ligne0[17]; 				// Tampon ligne 0 de l'afficheur LCD (16 caractres + /0)
;     238 char display_buffer_ligne1[17]; 				// Tampon ligne 1 de l'afficheur LCD            "
;     239 char pourcentage0[3], pourcentage1[3];  		// Affichage pourcentage PWM (0->95) (2 caractres + /0)
;     240 unsigned char rcycl=0, rcycl_1=0;       		// Saisie du rapport cyclique lors d'une modification manuelle
;     241 // Tableau des coefficients placs dans OCR1x pour le test "rglage du rapport cyclique du signal PWM"
;     242 unsigned char alpha[11] = {0,25,51,76,102,127,153,178,204,229,255}; 
;     243 unsigned char Cde_Del_IR;						// Permet de multiplexer la commande des LEDs des capteurs IR     
;     244 //============================================================================================================
;     245 
;     246 //============================================================================================================
;     247 // Initialisations
;     248 //------------------------------------------------------------------------------------------------------------
;     249 // Initialisation des priphriques
;     250 //------------------------------------------------------------------------------------------------------------                                        
;     251 // Input/Output Ports initialization
;     252 // Port A initialization
;     253 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;     254 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=1 State7=1 
;     255 				// Gestion des Emetteurs_IR 
;     256 PORTA=0xFF; 	// Dsactivation des E_IR  la mise sous tension
	SBIW R28,61
	LDI  R24,60
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	LDI  R30,LOW(_0x82*2)
	LDI  R31,HIGH(_0x82*2)
	CALL __INITLOCB
;	BP -> R16
;	Code_BP -> R17
;	i -> R18
;	NumServo -> R19
;	NumServo_1 -> R20
;	Aff_Cde_Servo -> R21
;	Aff_Cde_Servo_1 -> Y+60
;	decompte -> Y+59
;	decompte_1 -> Y+58
;	i_n -> Y+56
;	i_n_1 -> Y+54
;	display_buffer_ligne0 -> Y+37
;	display_buffer_ligne1 -> Y+20
;	pourcentage0 -> Y+17
;	pourcentage1 -> Y+14
;	rcycl -> Y+13
;	rcycl_1 -> Y+12
;	alpha -> Y+1
;	Cde_Del_IR -> Y+0
	LDI  R19,1
	LDI  R20,1
	LDI  R21,0
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     257 DDRA=0xFF;		// Port en sortie
	OUT  0x1A,R30
;     258 
;     259 // Port B initialization
;     260 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=Out Func7=Out
;     261 // State0=T State1=T State2=T State3=T State4=T State5=T State6=0 State7=0
;     262 PORTB=0x00;        // SERVO1 sur PB6, SERVO2 sur PB7
	CLR  R30
	OUT  0x18,R30
;     263 DDRB=0xC0;
	LDI  R30,LOW(192)
	OUT  0x17,R30
;     264 
;     265 // Port C initialization
;     266 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     267 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     268             // Gestion de l'afficheur LCD
;     269 PORTC=0x00; // Gre l'affichage, initialis par la fonction lcd_init(16);
	CLR  R30
	OUT  0x15,R30
;     270 DDRC=0x00;    
	OUT  0x14,R30
;     271 
;     272 // Port D initialization 
;     273 // Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=In Func6=Out Func7=In
;     274 // State0=T State1=T State2=T State3=0 State4=T State5=T State6=0 State7=T
;     275 				// Capteur magntique, moteurs, S4 et liaison srie
;     276 PORTD=0x30;     // Capteur magntique reli au 0V sur PD2
	LDI  R30,LOW(48)
	OUT  0x12,R30
;     277 DDRD=0xF0; 		// Broches PWM moteurs droit et gauche en sortie, initialise  1 
	LDI  R30,LOW(240)
	OUT  0x11,R30
;     278 				// Cde Servo 1 et 2 en sortie, Initialises  0
;     279 
;     280 // Timer/Counter 1 initialization
;     281 // Clock source: System Clock
;     282 // Clock value: 8000,000 kHz
;     283 // Mode: Ph. correct PWM top=00FFh
;     284 // OC1A output: Inverted
;     285 // OC1B output: Inverted
;     286 // Noise Canceler: Off
;     287 // Input Capture on Falling Edge
;     288 TCCR1A=0xF1; // 0xA1 pour robot 2008, 0xF1 pour robot 2009
	CALL SUBOPT_0x0
;     289 TCCR1B=0x01;
;     290 TCNT1H=0x00;
	CLR  R30
	OUT  0x2D,R30
;     291 TCNT1L=0x00;
	OUT  0x2C,R30
;     292 OCR1AH=0x00;
	OUT  0x2B,R30
;     293 OCR1AL=0x00;
	OUT  0x2A,R30
;     294 OCR1BH=0x00;
	OUT  0x29,R30
;     295 OCR1BL=0x00;
	OUT  0x28,R30
;     296 
;     297 // External Interrupt(s) initialization
;     298 // INT0: On
;     299 // INT0 Mode: Falling Edge
;     300 // INT1: Off
;     301 // INT2: Off
;     302 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
;     303 MCUCR=0x02;
	LDI  R30,LOW(2)
	OUT  0x35,R30
;     304 MCUCSR=0x00;
	CLR  R30
	OUT  0x34,R30
;     305 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     306 
;     307 // Analog Comparator initialization
;     308 // Analog Comparator: On
;     309 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     310 // Analog Comparator Output: Off
;     311 ACSR=0x00;
	CLR  R30
	OUT  0x8,R30
;     312 SFIOR=0x00;
	OUT  0x30,R30
;     313 
;     314 // LCD module initialization
;     315 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     316 //------------------------------------------------------------------------------------------------------------
;     317 // Chargement initial de la mmoire CGRAM de l'afficheur avec deux caractres personaliss  
;     318 //------------------------------------------------------------------------------------------------------------
;     319 for (i=0;i<8;i++)
	LDI  R18,LOW(0)
_0x84:
	CPI  R18,8
	BRSH _0x85
;     320 {
;     321  lcd_write_byte(Add_FlecheH_CGRAM + i, flecheHaut[i]); 	// @1 Caractre flche haut
	MOV  R30,R18
	SUBI R30,-LOW(64)
	ST   -Y,R30
	LDI  R26,LOW(_flecheHaut*2)
	LDI  R27,HIGH(_flecheHaut*2)
	CALL SUBOPT_0x1
	LPM  R30,Z
	ST   -Y,R30
	CALL _lcd_write_byte
;     322  lcd_write_byte(Add_FlecheB_CGRAM + i, flecheBas[i]); 	// @2 Caractre flche bas
	MOV  R30,R18
	SUBI R30,-LOW(72)
	ST   -Y,R30
	LDI  R26,LOW(_flecheBas*2)
	LDI  R27,HIGH(_flecheBas*2)
	CALL SUBOPT_0x1
	LPM  R30,Z
	ST   -Y,R30
	CALL _lcd_write_byte
;     323 }
	SUBI R18,-1
	RJMP _0x84
_0x85:
;     324 //------------------------------------------------------------------------------------------------------------
;     325 // Initialisation de la position des Servos
;     326 CDE_SERVO1 = 0;
	CBI  0x12,6
;     327 CDE_SERVO2 = 0;
	CBI  0x12,7
;     328 //------------------------------------------------------------------------------------------------------------
;     329 
;     330 //------------------------------------------------------------------------------------------------------------
;     331 // Message d'accueil
;     332 //------------------------------------------------------------------------------------------------------------
;     333 lcd_clear();
	CALL _lcd_clear
;     334 sprintf(display_buffer_ligne0,"****V_2.1.2a****"); // Version du logiciel  remplacer par le nom du robot
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     335 sprintf(display_buffer_ligne1,"---PEM BOURGES--");
	__POINTW1FN _129,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     336 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);   
;     337 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     338 //============================================================================================================ 
;     339 
;     340 //============================================================================================================
;     341 // Boucle principale
;     342 //------------------------------------------------------------------------------------------------------------
;     343 while (1)
_0x86:
;     344 {    
;     345   BP = Lire_BP_I2C_Soft(); 						// Lecture BP pour volution du graphe des menus 
	CALL _Lire_BP_I2C_Soft
	MOV  R16,R30
;     346   												// Gestion anti-rebonds     
;     347   Code_BP =  Lire_Port_I2C_Soft(Add_BP_I2C); 	// Lecture BP pour affichage sur les LED
	CALL SUBOPT_0x4
	MOV  R17,R30
;     348   												// Code BP = Code LED
;     349    
;     350    switch (Menu)
	__GETW1R 8,9
;     351    {// Dbut du switch principal    
;     352 //============================================================================================================
;     353 // Dbut Menus droulants 
;     354 ///============================================================================================================
;     355 // Dbut Menus droulants de NIVEAU 1 
;     356 //------------------------------------------------------------------------------------------------------------
;     357       case Menu_Reglages : if (Menu_1 != Menu)
	SBIW R30,0
	BRNE _0x8C
	__CPWRR 8,9,10,11
	BREQ _0x8D
;     358                        		{
;     359                         		sprintf(display_buffer_ligne0,"1 Regl coef Mot ");
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     360                        			sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
	__POINTW1FN _129,51
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     361                     			Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     362                        			Affiche_Fleche();
	CALL _Affiche_Fleche
;     363                        		}
;     364                       
;     365                          	switch(BP)
_0x8D:
	MOV  R30,R16
;     366                          	{                                   
;     367                       	   		case FlecheB_I2C: Menu = Menu_Tests;  break; // touche [flche bas]
	CPI  R30,LOW(0x4)
	BRNE _0x91
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	__PUTW1R 8,9
	RJMP _0x90
;     368                       	   		case FlecheH_I2C: Menu = Menu_Run;  break; // touche [flche haut]  
_0x91:
	CPI  R30,LOW(0x2)
	BRNE _0x92
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 8,9
	RJMP _0x90
;     369                       	   		case ENTR_I2C: Menu = Affiche_Reglages;  break; // touche [Enter]
_0x92:
	CPI  R30,LOW(0x40)
	BRNE _0x94
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	__PUTW1R 8,9
	RJMP _0x90
;     370                       	   		default: Menu = Menu_Reglages;
_0x94:
	CLR  R8
	CLR  R9
;     371                       	 	}
_0x90:
;     372                        
;     373        		         		Menu_1 = Menu_Reglages;
	CLR  R10
	CLR  R11
;     374        break; 
	RJMP _0x8B
;     375        
;     376        case Menu_Run : if (Menu_1 != Menu)
_0x8C:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x95
	__CPWRR 8,9,10,11
	BREQ _0x96
;     377                        		{
;     378                         		sprintf(display_buffer_ligne0,"2 Activ. Robot  ");
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,68
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     379                     			sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
	__POINTW1FN _129,85
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     380                     			Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     381                     			Affiche_Fleche();
	CALL _Affiche_Fleche
;     382                        		}
;     383                       
;     384                         	switch(BP)
_0x96:
	MOV  R30,R16
;     385                          	{         
;     386                       	   		case FlecheB_I2C: Menu = Menu_Reglages; break; // touche [flche bas]
	CPI  R30,LOW(0x4)
	BRNE _0x9A
	CLR  R8
	CLR  R9
	RJMP _0x99
;     387                       	   		case FlecheH_I2C: Menu = Menu_Tests; break; // touche [flche haut]
_0x9A:
	CPI  R30,LOW(0x2)
	BRNE _0x9B
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x286
;     388                       	   		case ENTR_I2C: Menu = Activation; break; // touche [Enter]
_0x9B:
	CPI  R30,LOW(0x40)
	BRNE _0x9D
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0x286
;     389                       	   		default: Menu = Menu_Run;
_0x9D:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x286:
	__PUTW1R 8,9
;     390                       	 	}
_0x99:
;     391                        
;     392        		        		Menu_1 = Menu_Run;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 10,11
;     393        break;      
	RJMP _0x8B
;     394        
;     395        case Menu_Tests : if (Menu_1 != Menu)
_0x95:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x9E
	__CPWRR 8,9,10,11
	BREQ _0x9F
;     396        					 	{
;     397                           		sprintf(display_buffer_ligne0,"3 Test du Robot ");
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,102
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     398                     	  		sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
	__POINTW1FN _129,119
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     399                     	  		Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     400                     	  		Affiche_Fleche();
	CALL _Affiche_Fleche
;     401                          	} 
;     402                        
;     403                        		switch(BP)
_0x9F:
	MOV  R30,R16
;     404                          	{                                  
;     405                       	   		case FlecheB_I2C: Menu = Menu_Run;  break; // touche [flche bas]
	CPI  R30,LOW(0x4)
	BRNE _0xA3
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x287
;     406                       	   		case FlecheH_I2C: Menu = Menu_Reglages;  break; // touche [flche haut]
_0xA3:
	CPI  R30,LOW(0x2)
	BRNE _0xA4
	CLR  R8
	CLR  R9
	RJMP _0xA2
;     407                       	   		case ENTR_I2C: Menu = Menu_Test_Servos;  break; // touche [Enter]
_0xA4:
	CPI  R30,LOW(0x40)
	BRNE _0xA6
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x287
;     408                       	   		default: Menu = Menu_Tests ;
_0xA6:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
_0x287:
	__PUTW1R 8,9
;     409                       	 	}
_0xA2:
;     410                        
;     411        		         		Menu_1 = Menu_Tests;
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	__PUTW1R 10,11
;     412        
;     413        break; 
	RJMP _0x8B
;     414 //------------------------------------------------------------------------------------------------------------          
;     415 // Fin Menus droulants de NIVEAU 1 
;     416 //============================================================================================================ 
;     417 //============================================================================================================   
;     418 // Dbut Menus droulants de NIVEAU 2 
;     419 //------------------------------------------------------------------------------------------------------------    
;     420        case Menu_Test_Servos : if (Menu_1 != Menu)
_0x9E:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0xA7
	__CPWRR 8,9,10,11
	BREQ _0xA8
;     421                        		{
;     422                         		sprintf(display_buffer_ligne0,"3.1 Test Servos ");
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,136
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     423                     			sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
	__POINTW1FN _129,153
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     424                        			Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     425                     			Affiche_Fleche();
	CALL _Affiche_Fleche
;     426                        		}
;     427                       
;     428                       		switch(BP)
_0xA8:
	MOV  R30,R16
;     429                       		{                                  
;     430                       	   		case FlecheB_I2C: Menu = Menu_Test_Capteurs_Cible;  break; 	// touche [flche bas]
	CPI  R30,LOW(0x4)
	BRNE _0xAC
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RJMP _0x288
;     431                       	   		case FlecheH_I2C: Menu = Menu_Test_Moteurs;  break; 		// touche [flche haut]
_0xAC:
	CPI  R30,LOW(0x2)
	BRNE _0xAD
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x288
;     432                       	   		case ECHAP_I2C: Menu = Menu_Tests; break; 					// touche [Echap]
_0xAD:
	CPI  R30,LOW(0x80)
	BRNE _0xAE
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x288
;     433                       	   		case ENTR_I2C: Menu = Cde_Servo;               				// touche [Enter] 
_0xAE:
	CPI  R30,LOW(0x40)
	BRNE _0xB0
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	__PUTW1R 8,9
;     434                       	   						Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;  
	CLR  R30
	SBIC 0x10,6
	LDI  R30,1
	MOV  R21,R30
;     435                       	   		break; 			
	RJMP _0xAB
;     436                       	   		default: Menu = Menu_Test_Servos;
_0xB0:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
_0x288:
	__PUTW1R 8,9
;     437                       	 	}
_0xAB:
;     438                        
;     439        		         		Menu_1 = Menu_Test_Servos;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	__PUTW1R 10,11
;     440        break; 
	RJMP _0x8B
;     441  
;     442        case Menu_Test_Moteurs : if (Menu_1 != Menu)
_0xA7:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0xB1
	__CPWRR 8,9,10,11
	BREQ _0xB2
;     443                         	{ 
;     444                          		sprintf(display_buffer_ligne0,"3.2 Tst Moteurs ");
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,170
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     445                     	 		sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
	__POINTW1FN _129,187
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     446                     	 		Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     447                     	 		Affiche_Fleche();
	CALL _Affiche_Fleche
;     448                         	}  
;     449                          
;     450                          	switch(BP)
_0xB2:
	MOV  R30,R16
;     451                          	{   
;     452                            		case FlecheB_I2C: Menu = Menu_Test_Servos;  break; // touche [flche bas]  
	CPI  R30,LOW(0x4)
	BRNE _0xB6
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x289
;     453                            		case FlecheH_I2C: Menu = Menu_Test_Capteurs_Ligne;  break; // touche [flche haut]
_0xB6:
	CPI  R30,LOW(0x2)
	BRNE _0xB7
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RJMP _0x289
;     454                       	   		case ECHAP_I2C: Menu = Menu_Tests; break; // touche [Echap]                          
_0xB7:
	CPI  R30,LOW(0x80)
	BRNE _0xB8
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x289
;     455                       	   		case ENTR_I2C: rcycl = 0; rcycl_1 = 0; Menu = Cde_Moteurs;  break; // touche [Enter] 
_0xB8:
	CPI  R30,LOW(0x40)
	BRNE _0xBA
	CLR  R30
	STD  Y+13,R30
	STD  Y+12,R30
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0x289
;     456                       	   		default: Menu = Menu_Test_Moteurs;
_0xBA:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
_0x289:
	__PUTW1R 8,9
;     457                       	 	}
;     458                        
;     459        		         		Menu_1 = Menu_Test_Moteurs;    
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1R 10,11
;     460         break;
	RJMP _0x8B
;     461         
;     462        case Menu_Test_Capteurs_Ligne : if (Menu_1 != Menu)
_0xB1:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0xBB
	__CPWRR 8,9,10,11
	BREQ _0xBC
;     463                         	{ 
;     464                          		sprintf(display_buffer_ligne0,"3.3 Tst CptLign ");
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,204
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     465                     	 		sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
	__POINTW1FN _129,221
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     466                     	 		Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     467                     	 		Affiche_Fleche();
	CALL _Affiche_Fleche
;     468                         	}
;     469                         	  
;     470                          	switch(BP)
_0xBC:
	MOV  R30,R16
;     471                          	{ 
;     472                            		case FlecheB_I2C: Menu = Menu_Test_Moteurs;  break; 	// touche [flche bas]
	CPI  R30,LOW(0x4)
	BRNE _0xC0
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x28A
;     473                            		case FlecheH_I2C: Menu = Menu_Test_Capteurs_Cible;  break; 	// touche [flche haut]
_0xC0:
	CPI  R30,LOW(0x2)
	BRNE _0xC1
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RJMP _0x28A
;     474                       	   		case ECHAP_I2C: Menu = Menu_Tests; break; 			// touche [Echap]                                 
_0xC1:
	CPI  R30,LOW(0x80)
	BRNE _0xC2
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x28A
;     475                       	   		case ENTR_I2C: Menu = Visu_Position;  break; 		// touche [Enter] 
_0xC2:
	CPI  R30,LOW(0x40)
	BRNE _0xC4
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RJMP _0x28A
;     476                     	   		default: Menu = Menu_Test_Capteurs_Ligne;
_0xC4:
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
_0x28A:
	__PUTW1R 8,9
;     477                       	 	}
;     478                        
;     479        		         		Menu_1 = Menu_Test_Capteurs_Ligne;    
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	__PUTW1R 10,11
;     480         break; 
	RJMP _0x8B
;     481         
;     482         case Menu_Test_Capteurs_Cible : if (Menu_1 != Menu)
_0xBB:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0xC5
	__CPWRR 8,9,10,11
	BREQ _0xC6
;     483                         	{ 
;     484                          		sprintf(display_buffer_ligne0,"3.4 Tst CptCibl ");
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,238
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x2
;     485                     	 		sprintf(display_buffer_ligne1,"[ENTR]>Oui      ");
	__POINTW1FN _129,255
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     486                     	 		Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     487                     	 		Affiche_Fleche();
	CALL _Affiche_Fleche
;     488                         	}
;     489                         	  
;     490                          	switch(BP)
_0xC6:
	MOV  R30,R16
;     491                          	{ 
;     492                            		case FlecheB_I2C: Menu = Menu_Test_Capteurs_Ligne;  break; 	// touche [flche bas]
	CPI  R30,LOW(0x4)
	BRNE _0xCA
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RJMP _0x28B
;     493                            		case FlecheH_I2C: Menu = Menu_Test_Servos;  break; 	// touche [flche haut]
_0xCA:
	CPI  R30,LOW(0x2)
	BRNE _0xCB
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x28B
;     494                       	   		case ECHAP_I2C: Menu = Menu_Tests; break; 			// touche [Echap]                                 
_0xCB:
	CPI  R30,LOW(0x80)
	BRNE _0xCC
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x28B
;     495                       	   		case ENTR_I2C: Menu = Visu_Cible; 					// touche [Enter] 
_0xCC:
	CPI  R30,LOW(0x40)
	BRNE _0xCE
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	__PUTW1R 8,9
;     496                       	   						#if PARCOURS_ROBOT == AVEC_ARRET  
;     497                       	   						#asm("sei");
	sei
;     498                       	   						#endif
;     499                       	   		break; 	
	RJMP _0xC9
;     500                     	   		default: Menu = Menu_Test_Capteurs_Cible;
_0xCE:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
_0x28B:
	__PUTW1R 8,9
;     501                       	 	}
_0xC9:
;     502                        
;     503        		         		Menu_1 = Menu_Test_Capteurs_Cible;    
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	__PUTW1R 10,11
;     504         break; 
	RJMP _0x8B
;     505 
;     506        case Affiche_Reglages : if ((Menu_1 != Menu) || (i_n_1 != i_n))   // Affichage des rglages PWM sous la forme d'un menu droulant
_0xC5:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BREQ PC+3
	JMP _0xCF
	__CPWRR 8,9,10,11
	BRNE _0xD1
	LDD  R30,Y+56
	LDD  R31,Y+56+1
	LDD  R26,Y+54
	LDD  R27,Y+54+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0xD1
	RJMP _0xD0
_0xD1:
;     507                          {
;     508                          if (fmod(i_n,2)==0) // Cas1: si l'indice i_n permettant de parcourir le tableau AFFICHE_REGLAGE est pair
	CALL SUBOPT_0x5
	BRNE _0xD3
;     509                              {
;     510                         	sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0); // Cas1: Affichage ligne (i_n/2) colonne 0 sur ligne 0 afficheur
	CALL SUBOPT_0x6
	MOVW R26,R30
	LDI  R30,LOW(_Tab_Aff_Reg*2)
	LDI  R31,HIGH(_Tab_Aff_Reg*2)
	PUSH R31
	PUSH R30
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x7
;     511                         	itoa(PWM_EEPROM[i_n/2][0],pourcentage0);
	ADD  R26,R30
	ADC  R27,R31
	CALL SUBOPT_0x8
	CALL SUBOPT_0x9
;     512                         	strcat(display_buffer_ligne0,pourcentage0);
;     513                        		sprintf(display_buffer_ligne1,Tab_Aff_Reg[i_n/2].ligne1); // Cas1: Affichage ligne (i_n/2) colonne 1 sur ligne 1 afficheur
	CALL SUBOPT_0xA
	PUSH R31
	PUSH R30
	__POINTW1FN _Tab_Aff_Reg,14
	POP  R26
	POP  R27
	PUSH R31
	PUSH R30
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x7
;     514                        		itoa(PWM_EEPROM[i_n/2][1],pourcentage1);
	CALL SUBOPT_0xB
	CALL SUBOPT_0xC
;     515                        	        strcat(display_buffer_ligne1,pourcentage1);
;     516                        		}
;     517                        		else  // si l'indice i_n permettant de parcourir le tableau AFFICHE_REGLAGE est impair
	RJMP _0xD4
_0xD3:
;     518                        		 { 
;     519                         	   sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);  // Cas2et3: Affichage ligne (i_n/2) colonne 1 sur ligne 0 afficheur
	CALL SUBOPT_0x6
	PUSH R31
	PUSH R30
	__POINTW1FN _Tab_Aff_Reg,14
	POP  R26
	POP  R27
	PUSH R31
	PUSH R30
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x7
;     520                                    itoa(PWM_EEPROM[i_n/2][1],pourcentage0);
	CALL SUBOPT_0xB
	CALL SUBOPT_0x9
;     521                                    strcat(display_buffer_ligne0,pourcentage0);
;     522                                 
;     523                                    if (i_n < 21) // et si la fin de la table AFFICHE_REGLAGE n'est pas atteinte 
	LDD  R26,Y+56
	LDD  R27,Y+56+1
	CPI  R26,LOW(0x15)
	LDI  R30,HIGH(0x15)
	CPC  R27,R30
	BRGE _0xD5
;     524                                     { 	
;     525                        		      sprintf(display_buffer_ligne1,Tab_Aff_Reg[(i_n/2)+1].ligne0); // cas2: Affichage ligne ((i_n/2)+1) colonne 0 sur ligne 1 afficheur
	CALL SUBOPT_0xA
	ADIW R30,1
	MOVW R26,R30
	LDI  R30,LOW(_Tab_Aff_Reg*2)
	LDI  R31,HIGH(_Tab_Aff_Reg*2)
	PUSH R31
	PUSH R30
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
;     526                        	              itoa(PWM_EEPROM[(i_n/2)+1][0],pourcentage1);
	LDD  R30,Y+56
	LDD  R31,Y+56+1
	ASR  R31
	ROR  R30
	ADIW R30,1
	CALL SUBOPT_0xD
	RJMP _0x28C
;     527                        	 	      strcat(display_buffer_ligne1,pourcentage1);
;     528                        	            }
;     529                        	            else // et si la fin de la table AFFICHE_REGLAGE est atteinte 
_0xD5:
;     530                        	            {
;     531                        		     sprintf(display_buffer_ligne1,Tab_Aff_Reg[0].ligne0); // cas3: Affichage ligne 0 colonne 0 sur ligne 1 afficheur
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Tab_Aff_Reg*2)
	LDI  R31,HIGH(_Tab_Aff_Reg*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
;     532                        	             itoa(PWM_EEPROM[0][0],pourcentage1);
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
_0x28C:
	CALL __EEPROMRDB
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xC
;     533                        	 	     strcat(display_buffer_ligne1,pourcentage1);
;     534                        	            }
;     535                        	         }
_0xD4:
;     536                     		Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
;     537                     		lcd_gotoxy(14,0);
	LDI  R30,LOW(14)
	CALL SUBOPT_0xE
;     538                     		lcd_putchar('%');
	CALL SUBOPT_0xF
;     539                     		lcd_gotoxy(15,0);	// Affichage flecheHaut
	CALL SUBOPT_0xE
;     540 							lcd_putchar(Caractere_FlecheH);
	CALL SUBOPT_0x10
;     541 							lcd_gotoxy(14,1);
	LDI  R30,LOW(14)
	CALL SUBOPT_0x11
;     542                     		lcd_putchar('%');	
	CALL SUBOPT_0xF
;     543 							lcd_gotoxy(15,1);	// Affichage flecheBas
	CALL SUBOPT_0x11
;     544 							lcd_putchar(Caractere_FlecheB);
	CALL SUBOPT_0x12
;     545 							i_n_1 = i_n; // Notifie que l'affichage a chang
	LDD  R30,Y+56
	LDD  R31,Y+56+1
	STD  Y+54,R30
	STD  Y+54+1,R31
;     546                        		  }
;     547                       
;     548                          switch(BP)
_0xD0:
	MOV  R30,R16
;     549                          { 
;     550                       	   // Gestion de l'indice i_n du tableau AFFICHE_REGLAGE dans l'intervalle [0,21]
;     551                       	   case FlecheH_I2C: if (i_n < 21) i_n++; else i_n=0; break; // touche [flche haut]
	CPI  R30,LOW(0x2)
	BRNE _0xDA
	LDD  R26,Y+56
	LDD  R27,Y+56+1
	CPI  R26,LOW(0x15)
	LDI  R30,HIGH(0x15)
	CPC  R27,R30
	BRGE _0xDB
	LDD  R30,Y+56
	LDD  R31,Y+56+1
	ADIW R30,1
	STD  Y+56,R30
	STD  Y+56+1,R31
	RJMP _0xDC
_0xDB:
	CLR  R30
	STD  Y+56,R30
	STD  Y+56+1,R30
_0xDC:
	RJMP _0xD9
;     552                       	   case FlecheB_I2C: if (i_n > 0) i_n--; else i_n=21; break; // touche [flche bas]
_0xDA:
	CPI  R30,LOW(0x4)
	BRNE _0xDD
	LDD  R26,Y+56
	LDD  R27,Y+56+1
	CALL __CPW02
	BRGE _0xDE
	LDD  R30,Y+56
	LDD  R31,Y+56+1
	SBIW R30,1
	RJMP _0x28D
_0xDE:
	LDI  R30,LOW(21)
	LDI  R31,HIGH(21)
_0x28D:
	STD  Y+56,R30
	STD  Y+56+1,R31
	RJMP _0xD9
;     553                       	   case ECHAP_I2C: Menu = Menu_Reglages; break; 	    // touche [Echap]
_0xDD:
	CPI  R30,LOW(0x80)
	BRNE _0xE0
	CLR  R8
	CLR  R9
	RJMP _0xD9
;     554                       	   // La touche [Enter] fait passer la donne prsente sur la premire 
;     555                            // ligne de l'afficheur en mode modification                                 
;     556                       	   case ENTR_I2C:  if (fmod(i_n,2)==0) // si i_n pair     
_0xE0:
	CPI  R30,LOW(0x40)
	BRNE _0xE4
	CALL SUBOPT_0x5
	BRNE _0xE2
;     557                       	                 rcycl = PWM_EEPROM[i_n/2][0];
	LDD  R30,Y+56
	LDD  R31,Y+56+1
	ASR  R31
	ROR  R30
	CALL SUBOPT_0xD
	RJMP _0x28E
;     558                       	   	     else  // si i_n impair   
_0xE2:
;     559                       	   	           rcycl = PWM_EEPROM[i_n/2][1];
	CALL SUBOPT_0x13
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,1
	MOVW R26,R30
_0x28E:
	CALL __EEPROMRDB
	STD  Y+13,R30
;     560                       	   	         
;     561                       	             Menu = Reglage_PWM;  
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x28F
;     562                       	   break;  
;     563                       	   default: Menu = Affiche_Reglages;
_0xE4:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
_0x28F:
	__PUTW1R 8,9
;     564                       	 }
_0xD9:
;     565                        
;     566        		       		Menu_1 = Affiche_Reglages;
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	__PUTW1R 10,11
;     567        break;   
	RJMP _0x8B
;     568 //------------------------------------------------------------------------------------------------------------           
;     569 // Fin Menus droulants de NIVEAU 2 
;     570 //============================================================================================================
;     571 // Fin Menus droulants
;     572 //============================================================================================================
;     573                
;     574         case Reglage_PWM : if ((Menu_1 != Menu)|| (rcycl_1 != rcycl))
_0xCF:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ PC+3
	JMP _0xE5
	__CPWRR 8,9,10,11
	BRNE _0xE7
	CALL SUBOPT_0x14
	BRNE _0xE7
	RJMP _0xE6
_0xE7:
;     575                        { 
;     576                         if (fmod(i_n,2)==0) // si i_n pair
	CALL SUBOPT_0x5
	BRNE _0xE9
;     577                            { 
;     578                              sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0);
	CALL SUBOPT_0x6
	MOVW R26,R30
	LDI  R30,LOW(_Tab_Aff_Reg*2)
	LDI  R31,HIGH(_Tab_Aff_Reg*2)
	PUSH R31
	PUSH R30
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x290
;     579                              itoa(rcycl,pourcentage0);
;     580                              strcat(display_buffer_ligne0,pourcentage0);
;     581                            }
;     582                         else  // si i_n impair
_0xE9:
;     583                            {
;     584                              sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);
	CALL SUBOPT_0x6
	PUSH R31
	PUSH R30
	__POINTW1FN _Tab_Aff_Reg,14
	POP  R26
	POP  R27
	PUSH R31
	PUSH R30
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
_0x290:
	CALL _sprintf
	ADIW R28,4
;     585                              itoa(rcycl,pourcentage0);
	LDD  R30,Y+13
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x9
;     586                              strcat(display_buffer_ligne0,pourcentage0);
;     587                            }
;     588                     	sprintf(display_buffer_ligne1,"ENTR>Memo [ECH]");
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,272
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     589                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     590                     	lcd_gotoxy(15,0);
	LDI  R30,LOW(15)
	CALL SUBOPT_0xE
;     591 						lcd_putchar('+');
	LDI  R30,LOW(43)
	ST   -Y,R30
	CALL _lcd_putchar
;     592 						lcd_gotoxy(15,1);
	LDI  R30,LOW(15)
	CALL SUBOPT_0x11
;     593 						lcd_putchar('-');
	LDI  R30,LOW(45)
	ST   -Y,R30
	CALL _lcd_putchar
;     594 						rcycl_1 = rcycl; // Notifie que l'affichage a chang
	LDD  R30,Y+13
	STD  Y+12,R30
;     595                        }
;     596                       
;     597                          switch(BP)
_0xE6:
	MOV  R30,R16
;     598                          { // Rglage du rapport cyclique par pas de 5%
;     599                            case MOINS_I2C: if (rcycl > 5) rcycl = rcycl-5; else rcycl = 0; break; // touche [-] 
	CPI  R30,LOW(0x8)
	BRNE _0xEE
	LDD  R26,Y+13
	LDI  R30,LOW(5)
	CP   R30,R26
	BRSH _0xEF
	LDD  R30,Y+13
	SUBI R30,LOW(5)
	RJMP _0x291
_0xEF:
	CLR  R30
_0x291:
	STD  Y+13,R30
	RJMP _0xED
;     600                            case PLUS_I2C: if (rcycl < 100) rcycl = rcycl+5; else rcycl = 100; break; // touche [+]
_0xEE:
	CPI  R30,LOW(0x1)
	BRNE _0xF1
	LDD  R26,Y+13
	CPI  R26,LOW(0x64)
	BRSH _0xF2
	LDD  R30,Y+13
	SUBI R30,-LOW(5)
	RJMP _0x292
_0xF2:
	LDI  R30,LOW(100)
_0x292:
	STD  Y+13,R30
	RJMP _0xED
;     601                            case ECHAP_I2C: Menu = Affiche_Reglages;  break; // touche [Echap]
_0xF1:
	CPI  R30,LOW(0x80)
	BRNE _0xF4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP _0x293
;     602                            case ENTR_I2C: if (fmod(i_n,2)==0) // si i_n pair touche [Entr]
_0xF4:
	CPI  R30,LOW(0x40)
	BRNE _0xF8
	CALL SUBOPT_0x5
	BRNE _0xF6
;     603                       	                  PWM_EEPROM[i_n/2][0]=rcycl;
	CALL SUBOPT_0x13
	ADD  R26,R30
	ADC  R27,R31
	RJMP _0x294
;     604                       	   	     else // si i_n impair
_0xF6:
;     605                       	   	          PWM_EEPROM[i_n/2][1]=rcycl;
	CALL SUBOPT_0x13
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,1
	MOVW R26,R30
_0x294:
	LDD  R30,Y+13
	CALL __EEPROMWRB
;     606                       	   	     
;     607                       	   	     Menu = Affiche_Reglages;     
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP _0x293
;     608                       	   break;                                  
;     609                       	   default: Menu = Reglage_PWM;
_0xF8:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
_0x293:
	__PUTW1R 8,9
;     610                       	 }
_0xED:
;     611                        
;     612        		       Menu_1 = Reglage_PWM;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1R 10,11
;     613        break;   
	RJMP _0x8B
;     614        
;     615        case Activation : if ((Menu_1 != Menu) || (decompte != decompte_1))
_0xE5:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0xF9
	__CPWRR 8,9,10,11
	BRNE _0xFB
	LDD  R30,Y+58
	LDD  R26,Y+59
	CP   R30,R26
	BREQ _0xFA
_0xFB:
;     616                        {
;     617                         sprintf(display_buffer_ligne0,"Depart dans %-us",decompte);
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,288
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+63
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL SUBOPT_0x15
;     618                     	sprintf(display_buffer_ligne1,"[Ech]>Desactiver");
	__POINTW1FN _129,305
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     619                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     620                     	decompte_1 = decompte; // Notifie que l'affichage a chang
	LDD  R30,Y+59
	STD  Y+58,R30
;     621                        }
;     622                        
;     623                      	 if (BP==ECHAP_I2C) { // touche [Echap] pour sortir du dcompte
_0xFA:
	CPI  R16,128
	BRNE _0xFD
;     624                                    				decompte=5; // Rglage 5s
	LDI  R30,LOW(5)
	STD  Y+59,R30
;     625                                    				Menu=Menu_Reglages;
	CLR  R8
	CLR  R9
;     626                                    				break;
	RJMP _0x8B
;     627                      		 				}
;     628                          else if(decompte == 0) 
_0xFD:
	LDD  R30,Y+59
	CPI  R30,0
	BRNE _0xFF
;     629                      		       				Mode_Run();
	RCALL _Mode_Run
;     630                      delay_ms(1000); decompte--;
_0xFF:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDD  R30,Y+59
	SUBI R30,LOW(1)
	STD  Y+59,R30
;     631                      Menu_1 = Activation;
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	__PUTW1R 10,11
;     632       break; 
	RJMP _0x8B
;     633       
;     634       case Cde_Servo : if ((Menu_1 != Menu) || (NumServo != NumServo_1)|| (Aff_Cde_Servo != Aff_Cde_Servo_1))
_0xF9:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x100
	__CPWRR 8,9,10,11
	BRNE _0x102
	CP   R20,R19
	BRNE _0x102
	LDD  R30,Y+60
	CP   R30,R21
	BREQ _0x101
_0x102:
;     635                        {
;     636                         sprintf(display_buffer_ligne0,"Cde Servo_%-u= %-u   ",NumServo,Aff_Cde_Servo);
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,322
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R19
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOV  R30,R21
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
;     637                     	sprintf(display_buffer_ligne1,"[+] [-] [Echp]  ");
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,344
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     638                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     639                     	Affiche_Fleche();
	CALL _Affiche_Fleche
;     640                     	NumServo_1 = NumServo; // Notifie que l'affichage a chang
	MOV  R20,R19
;     641                     	Aff_Cde_Servo_1 = Aff_Cde_Servo;
	STD  Y+60,R21
;     642                        }
;     643                        
;     644                        switch(BP)
_0x101:
	MOV  R30,R16
;     645                          { 
;     646                            case MOINS_I2C: 	 									// touche [-]
	CPI  R30,LOW(0x8)
	BRNE _0x107
;     647                      						if (NumServo==1) {CDE_SERVO1 = 0; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}					
	CPI  R19,1
	BRNE _0x108
	CBI  0x12,6
	CLR  R30
	SBIC 0x10,6
	LDI  R30,1
	MOV  R21,R30
;     648                       	   					if (NumServo==2) {CDE_SERVO2 = 0; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}	
_0x108:
	CPI  R19,2
	BRNE _0x109
	CBI  0x12,7
	CLR  R30
	SBIC 0x10,7
	LDI  R30,1
	MOV  R21,R30
;     649                       	   break; 
_0x109:
	RJMP _0x106
;     650                       	  
;     651                       	   case PLUS_I2C: 				 					// touche [+]
_0x107:
	CPI  R30,LOW(0x1)
	BRNE _0x10A
;     652                            					if (NumServo==1) {CDE_SERVO1 = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}					
	CPI  R19,1
	BRNE _0x10B
	SBI  0x12,6
	CLR  R30
	SBIC 0x10,6
	LDI  R30,1
	MOV  R21,R30
;     653                       	   					if (NumServo==2) {CDE_SERVO2 = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
_0x10B:
	CPI  R19,2
	BRNE _0x10C
	SBI  0x12,7
	CLR  R30
	SBIC 0x10,7
	LDI  R30,1
	MOV  R21,R30
;     654                       	   break; 
_0x10C:
	RJMP _0x106
;     655 
;     656                       	   case ECHAP_I2C: 	CDE_SERVO1 = 0; CDE_SERVO2 = 0; 	// touche [Echap] 
_0x10A:
	CPI  R30,LOW(0x80)
	BRNE _0x10D
	CBI  0x12,6
	CBI  0x12,7
;     657                       	   					Menu = Menu_Test_Servos; 
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x295
;     658                       	   break;
;     659                       	   
;     660                       	   case FlecheB_I2C: if (NumServo == 1) {NumServo = 2; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
_0x10D:
	CPI  R30,LOW(0x4)
	BRNE _0x10E
	CPI  R19,1
	BRNE _0x10F
	LDI  R19,LOW(2)
	CLR  R30
	SBIC 0x10,7
	LDI  R30,1
	MOV  R21,R30
;     661                       	   		   		else if (NumServo == 2) {NumServo = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}
	RJMP _0x110
_0x10F:
	CPI  R19,2
	BRNE _0x111
	LDI  R19,LOW(1)
	CLR  R30
	SBIC 0x10,6
	LDI  R30,1
	MOV  R21,R30
;     662                       	   break;
_0x111:
_0x110:
	RJMP _0x106
;     663                       	   
;     664                       	   case FlecheH_I2C: if (NumServo == 1) {NumServo = 2; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
_0x10E:
	CPI  R30,LOW(0x2)
	BRNE _0x116
	CPI  R19,1
	BRNE _0x113
	LDI  R19,LOW(2)
	CLR  R30
	SBIC 0x10,7
	LDI  R30,1
	MOV  R21,R30
;     665                       	   		   		else if (NumServo == 2) {NumServo = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}
	RJMP _0x114
_0x113:
	CPI  R19,2
	BRNE _0x115
	LDI  R19,LOW(1)
	CLR  R30
	SBIC 0x10,6
	LDI  R30,1
	MOV  R21,R30
;     666                       	   break;
_0x115:
_0x114:
	RJMP _0x106
;     667                       	   
;     668                       	   default: Menu = Cde_Servo;
_0x116:
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
_0x295:
	__PUTW1R 8,9
;     669                       	 } 
_0x106:
;     670                       	 
;     671                      Menu_1 = Cde_Servo;
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	__PUTW1R 10,11
;     672       break;
	RJMP _0x8B
;     673       
;     674       
;     675         
;     676       case Cde_Moteurs :  if ((Menu_1 != Menu)|| (rcycl_1 != rcycl))
_0x100:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x117
	__CPWRR 8,9,10,11
	BRNE _0x119
	CALL SUBOPT_0x14
	BREQ _0x118
_0x119:
;     677        			  		  {
;     678        		   	    	   sprintf(display_buffer_ligne0,"Rap. cycl = %-u%%",rcycl);
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,361
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL SUBOPT_0x15
;     679        		               sprintf(display_buffer_ligne1,"[+] [-] [Echap] ");
	__POINTW1FN _129,379
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     680        		               Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
;     681        		               rcycl_1 = rcycl; 
	LDD  R30,Y+13
	STD  Y+12,R30
;     682 			  			  }   
;     683 			  
;     684 		           	  	  switch(BP)
_0x118:
	MOV  R30,R16
;     685 			               {  
;     686 			        		case MOINS_I2C: if (rcycl > 10) rcycl = rcycl-10; else rcycl = 0; break; // touche [-]
	CPI  R30,LOW(0x8)
	BRNE _0x11E
	LDD  R26,Y+13
	LDI  R30,LOW(10)
	CP   R30,R26
	BRSH _0x11F
	LDD  R30,Y+13
	SUBI R30,LOW(10)
	RJMP _0x296
_0x11F:
	CLR  R30
_0x296:
	STD  Y+13,R30
	RJMP _0x11D
;     687 							case PLUS_I2C: if (rcycl < 90) rcycl = rcycl+10; else rcycl = 100; break; // touche [+]
_0x11E:
	CPI  R30,LOW(0x1)
	BRNE _0x121
	LDD  R26,Y+13
	CPI  R26,LOW(0x5A)
	BRSH _0x122
	LDD  R30,Y+13
	SUBI R30,-LOW(10)
	RJMP _0x297
_0x122:
	LDI  R30,LOW(100)
_0x297:
	STD  Y+13,R30
	RJMP _0x11D
;     688 							case ECHAP_I2C : rcycl = 0; Menu = Menu_Test_Moteurs; break; // touche [Echap]
_0x121:
	CPI  R30,LOW(0x80)
	BRNE _0x125
	CLR  R30
	STD  Y+13,R30
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x298
;     689 				   			default: Menu = Cde_Moteurs;
_0x125:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
_0x298:
	__PUTW1R 8,9
;     690                            }
_0x11D:
;     691                                  
;     692                         // Transfert des rapports cycliques      
;     693 							OCR1AL=alpha[rcycl/10];
	CALL SUBOPT_0x16
	OUT  0x2A,R30
;     694 							OCR1BL=alpha[rcycl/10];
	CALL SUBOPT_0x16
	OUT  0x28,R30
;     695          					Menu_1 = Cde_Moteurs ;      		      
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1R 10,11
;     696      break;           
	RJMP _0x8B
;     697      
;     698      case Visu_Position :       // ------------------------------------------------------------------------------------
_0x117:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x126
;     699 								// Fonction acqurir la position du robot par rapport  la ligne
;     700 								// ------------------------------------------------------------------------------------
;     701       							Position_Robot = HORS_LIGNE; // Initialisation  0	
	CLR  R4
	CLR  R5
;     702       							Cde_Del_IR = 1; 
	LDI  R30,LOW(1)
	ST   Y,R30
;     703  
;     704  				for (i=0;i<5;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
	LDI  R18,LOW(0)
_0x128:
	CPI  R18,5
	BRSH _0x129
;     705        				{
;     706         			  CAPTEUR_IR = ~Cde_Del_IR;
	LD   R30,Y
	CALL SUBOPT_0x17
;     707       				  delay_us(30);	// Temps d'activation d'un capteur ( ajuster : 9s par dfaut)
;     708         			  if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;
	SBIS 0x8,5
	RJMP _0x12A
	LD   R30,Y
	CALL SUBOPT_0x18
;     709         			  CAPTEUR_IR = 0xFF;
_0x12A:
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     710         			  Cde_Del_IR = Cde_Del_IR << 1 ;
	LD   R30,Y
	LSL  R30
	ST   Y,R30
;     711         			  delay_us(540); //  ajuster   (540s par dfaut)
	__DELAY_USW 1080
;     712        				} 
	SUBI R18,-1
	RJMP _0x128
_0x129:
;     713        				
;     714        				delay_us(1500);
	__DELAY_USW 3000
;     715        				// Fin Acquisition de la position du robot par rapport  la ligne
;     716 				// ------------------------------------------------------------------------------------ 
;     717 				
;     718      				if ((Menu_1 != Menu)|| (Position_Robot != Position_Robot_1))
	__CPWRR 8,9,10,11
	BRNE _0x12C
	__CPWRR 6,7,4,5
	BRNE _0x12C
	RJMP _0x12B
_0x12C:
;     719      			        {
;     720 						// ------------------------------------------------------------------------------------
;     721 						// Fonction Visualiser (Visualisation des capteurs sur la ligne)
;     722 						// ------------------------------------------------------------------------------------
;     723 				 	switch (Position_Robot)              
	__GETW1R 4,5
;     724        				 { 
;     725        				  case HORS_LIGNE:  	sprintf(display_buffer_ligne0,"Pos = Hors ligne"); break; // Hors ligne
	SBIW R30,0
	BRNE _0x131
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,396
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     726        				  case GAUCHE_3PLUS:  	sprintf(display_buffer_ligne0,"Pos = Gauche 3+ "); break; // Gauche3+
_0x131:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x132
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,413
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     727   				  	  case GAUCHE_2PLUS:  	sprintf(display_buffer_ligne0,"Pos = Gauche 2+ "); break; // Gauche2+
_0x132:
	CPI  R30,LOW(0x18)
	LDI  R26,HIGH(0x18)
	CPC  R31,R26
	BRNE _0x133
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,430
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     728        				  case CENTRE_1:  		sprintf(display_buffer_ligne0,"Pos = Centre    "); break; // Centre1 non visualis
_0x133:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x134
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,447
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     729         			  case GAUCHE_PLUS:  	sprintf(display_buffer_ligne0,"Pos = Gauche +  "); break; // Gauche+  
_0x134:
	CPI  R30,LOW(0x1C)
	LDI  R26,HIGH(0x1C)
	CPC  R31,R26
	BRNE _0x135
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,464
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     730         			  case CENTRE_3: 		sprintf(display_buffer_ligne0,"Pos = Centre    "); break; // Centre3 
_0x135:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BRNE _0x136
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,481
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     731         			  case GAUCHE: 			sprintf(display_buffer_ligne0,"Pos = Gauche    "); break; // Gauche 
_0x136:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x137
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,498
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     732         			  case DROITE_3PLUS: 	sprintf(display_buffer_ligne0,"Pos = Droite 3+ "); break; // Droite3+
_0x137:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x138
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,515
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     733         			  case DROITE_2PLUS: 	sprintf(display_buffer_ligne0,"Pos = Droite 2+ "); break; // Droite2+  
_0x138:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x139
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,532
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     734         			  case DROITE_PLUS: 	sprintf(display_buffer_ligne0,"Pos = Droite +  "); break; // Droite+ 
_0x139:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x13A
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,549
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     735         			  case DROITE: 			sprintf(display_buffer_ligne0,"Pos = Droite    "); break; // Droite 
_0x13A:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0x13B
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,566
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     736         			  case CENTRE_5: 		sprintf(display_buffer_ligne0,"Pos = Centre    "); break; // Centre5 
_0x13B:
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	BRNE _0x13D
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,583
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x299
;     737         			  default: 				sprintf(display_buffer_ligne0,"Pos = ?????     "); // Erreur mesure
_0x13D:
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,600
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
_0x299:
	CALL _sprintf
	ADIW R28,4
;     738        				 }   
;     739      			        
;     740        				sprintf(display_buffer_ligne1,"         [ECHAP]");
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,617
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     741        				Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     742        				Position_Robot_1 = Position_Robot;
	__MOVEWRR 6,7,4,5
;     743            			}
;     744      			
;     745      				if (BP == ECHAP_I2C) Menu = Menu_Test_Capteurs_Ligne; // touche [Echap]
_0x12B:
	CPI  R16,128
	BRNE _0x13E
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RJMP _0x29A
;     746      			 		else Menu = Visu_Position;
_0x13E:
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
_0x29A:
	__PUTW1R 8,9
;     747      			 		
;     748            		Menu_1 = Visu_Position;
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	__PUTW1R 10,11
;     749       break;  
	RJMP _0x8B
;     750       
;     751       
;     752       #if PARCOURS_ROBOT == AVEC_ARRET
;     753       case Visu_Cible:  GICR=0x40; // Activation INT0
_0x126:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x8B
	LDI  R30,LOW(64)
	OUT  0x3B,R30
;     754       			    	if ((Menu_1 != Menu)|| (Cible != Cible_1))
	__CPWRR 8,9,10,11
	BRNE _0x142
	CLR  R30
	SBRC R2,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBRC R2,1
	LDI  R30,1
	POP  R26
	CP   R30,R26
	BREQ _0x141
_0x142:
;     755       			    	{ 
;     756       						switch (Cible) // Cible passe  1 lorsque le robot est devant la cible  
	CLR  R30
	SBRC R2,0
	LDI  R30,1
;     757       						{
;     758       						 case 0: sprintf(display_buffer_ligne0,"Regler pos capt.");
	CPI  R30,0
	BRNE _0x147
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,634
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
;     759       						 break;
	RJMP _0x146
;     760       						  
;     761       						 case 1: sprintf(display_buffer_ligne0,"Pos capteur Ok  ");
_0x147:
	CPI  R30,LOW(0x1)
	BRNE _0x146
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,651
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
;     762       						 		 Cible = 0;   
	CLT
	BLD  R2,0
;     763         					 break; 	
;     764         					}
_0x146:
;     765         					
;     766         					sprintf(display_buffer_ligne1,"         [ECHAP]");      
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _129,668
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL SUBOPT_0x3
;     767        						Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     768        				  		Cible_1 = Cible;
	BST  R2,0
	BLD  R2,1
;     769                     	}
;     770                     	
;     771      					if (BP == ECHAP_I2C) 					// touche [Echap]
_0x141:
	CPI  R16,128
	BRNE _0x149
;     772      						{
;     773      							Menu = Menu_Test_Capteurs_Cible; 
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	__PUTW1R 8,9
;     774      							Active_Moteurs();  // Ractivation PWM (Dsactive dans l'INT0)
	CALL _Active_Moteurs
;     775      							#asm("cli")
	cli
;     776      						}
;     777      			 	   		else Menu = Visu_Cible;
	RJMP _0x14A
_0x149:
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	__PUTW1R 8,9
_0x14A:
;     778       
;     779       					Menu_1 = Visu_Cible;
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	__PUTW1R 10,11
;     780       break; 
;     781       
;     782       #elif PARCOURS_ROBOT == SANS_ARRET 
;     783       case Visu_Cible:  if (Menu_1 != Menu)
;     784       			    	{
;     785       			    	   sprintf(display_buffer_ligne0,"!Test desactive!");
;     786       			    	   sprintf(display_buffer_ligne1,"Compil Avec_Arre"); 
;     787       			    	   Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
;     788       			    	} 
;     789       			    		if (BP == ECHAP_I2C) 					// touche [Echap]
;     790      						{
;     791      							Menu = Menu_Test_Capteurs_Cible; 
;     792      						}
;     793      			 	   		else Menu = Visu_Cible;
;     794       
;     795       					Menu_1 = Visu_Cible;
;     796       break; 
;     797       #endif
;     798                                                            
;     799   } // Fin du switch principal 
_0x8B:
;     800 //============================================================================================================ 
;     801   Ecrire_Port_I2C_Soft(Add_LED_I2C,~Code_BP); // Visualisation de la position du robot sur les LED
	LDI  R30,LOW(64)
	ST   -Y,R30
	MOV  R30,R17
	COM  R30
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
;     802 //============================================================================================================
;     803  } // Fin du while(1)
	RJMP _0x86
;     804 //============================================================================================================
;     805 } // fin du main 
	ADIW R28,61
_0x14B:
	RJMP _0x14B
;     806 //============================================================================================================  
;     807 // Lien vers le travail Elve  : SOUS-PROGRAMME Mode_RUN()
;     808 //------------------------------------------------------------------------------------------------------------    
;     809 #include "RB_ELEVE.c" 
;     810 //============================================================================================================
;     811 //============================================================================================================
;     812 // ******************************** SOUS-PROGRAMME SUIVI DE LIGNE ELEVE **************************************
;     813 //============================================================================================================
;     814 //============================================================================================================
;     815 // 	Mode_Run() : LE ROBOT EFFECTUE SON PARCOURS
;     816 //------------------------------------------------------------------------------------------------------------
;     817 // !!!!!!!!! Attention : on sort du menu Mode_Run par une coupure d'alimentation !!!!!!!!
;     818 //============================================================================================================
;     819 void Mode_Run()
;     820 {
_Mode_Run:
;     821 //------------------------------------------------------------------------------------------------------------ 
;     822 // Variables locale  Mode_Run()  
;     823 //------------------------------------------------------------------------------------------------------------
;     824 // type			nom						Commentaires
;     825 //------------------------------------------------------------------------------------------------------------ 
;     826 unsigned char i,j,k;            // Compteurs des boucles utilises pour transfrer en RAM, les valeurs 
;     827 								// correspondant aux %rapports cycliques sauvegardes dans l'eeprom
;     828 unsigned char VisuPosition;		// Contient la valeur transmise aux Leds pendant le dplacement 
;     829 unsigned char PWM[11][2];		// Contient les coefficients destins au Timers(PWM) pour le rglage de la 
;     830 								// frquence de rotation des moteurs. 
;     831 unsigned char Cde_Del_IR;		// Permet de multiplexer la commande des Leds des capteurs IR
;     832 
;     833 #if PARCOURS_ROBOT == AVEC_ARRET
;     834 unsigned int Phase_Arret = 50;	// Compteur de boucle : Autorise la mesure de la position du robot
;     835 								// pendant 200ms aprs l'arrt des moteurs devant la cible 
;     836 #endif
;     837 //============================================================================================================
;     838  
;     839 //============================================================================================================
;     840 // INITIALISATIONS
;     841 //------------------------------------------------------------------------------------------------------------                                      
;     842 // Initialisation du mode Run: Chargement de la table PWM[][] avec les paramtres sauvegards en EEPROM
;     843 // i, k: compteur ligne, j compteur colonne    
;     844 // PWM_EEPROM[11,2] contient %Rapports cycliques -->  TABLE_CALCUL_OCRIx[21][2] --> PWM[11][2]
;     845 //------------------------------------------------------------------------------------------------------------
;     846 for (i=0;i<11;i++)  // La valeur de I dpend du nombre de capteurs utiliss
	SBIW R28,24
	LDI  R24,2
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x14D*2)
	LDI  R31,HIGH(_0x14D*2)
	CALL __INITLOCB
	CALL __SAVELOCR5
;	i -> R16
;	j -> R17
;	k -> R18
;	VisuPosition -> R19
;	PWM -> Y+7
;	Cde_Del_IR -> R20
;	Phase_Arret -> Y+5
	LDI  R16,LOW(0)
_0x14F:
	CPI  R16,11
	BRSH _0x150
;     847  { 
;     848   for (j=0;j<2;j++)
	LDI  R17,LOW(0)
_0x152:
	CPI  R17,2
	BRSH _0x153
;     849    { 
;     850     for (k=0;k<21;k++) // La valeur de k dpend du nombre de rglage PWM contenue dans la table
	LDI  R18,LOW(0)
_0x155:
	CPI  R18,21
	BRSH _0x156
;     851      {				   // Table_Calcul_OCR1x situe dans le fichier RB_Eleve.h
;     852        if (PWM_EEPROM[i][j] == Table_Calcul_OCR1x[k][0])
	MOV  R30,R16
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	CLR  R31
	CALL SUBOPT_0x19
	ADD  R26,R30
	ADC  R27,R31
	CALL __EEPROMRDB
	PUSH R30
	CALL SUBOPT_0x1A
	LPM  R30,Z
	POP  R26
	CP   R30,R26
	BRNE _0x157
;     853        {   
;     854 	     PWM[i][j] = Table_Calcul_OCR1x[k][1];
	MOV  R30,R16
	CLR  R31
	MOVW R26,R28
	ADIW R26,7
	CALL SUBOPT_0x19
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1A
	ADIW R30,1
	LPM  R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     855 	     break;
	RJMP _0x156
;     856 	   }
;     857      }
_0x157:
	SUBI R18,-1
	RJMP _0x155
_0x156:
;     858    }
	SUBI R17,-1
	RJMP _0x152
_0x153:
;     859  }  
	SUBI R16,-1
	RJMP _0x14F
_0x150:
;     860 //------------------------------------------------------------------------------------------------------------  
;     861 // Global enable interrupts
;     862 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
;     863 // ATTENTION VOIR PROF: A dsactiver dans l'en tte du fichier RB_x_x_x.c en prcisant SANS_ARRET devant
;     864 // # define PARCOURS_ROBOT si la carte capteur cible n'est pas monte sur le robot 
;     865 //------------------------------------------------------------------------------------------------------------ 
;     866 #if PARCOURS_ROBOT == AVEC_ARRET
;     867 #asm("sei") 
	sei
;     868 #endif
;     869 //------------------------------------------------------------------------------------------------------------
;     870 // Fin initialisations
;     871 //============================================================================================================ 
;     872 
;     873 //============================================================================================================
;     874 // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! BOUCLE INFINIE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;     875 //------------------------------------------------------------------------------------------------------------
;     876 while (1)
_0x158:
;     877     {// dbut Mode_Run() 
;     878 //============================================================================================================ 
;     879 // GESTION DE LA BALLE   
;     880 // ATTENTION VOIR PROF: A dsactiver dans l'en tte du fichier RB_x_x_x.c en prcisant SANS_ARRET devant
;     881 // # define PARCOURS_ROBOT si la carte capteur cible n'est pas monte sur le robot 
;     882 //------------------------------------------------------------------------------------------------------------
;     883 // Phase d'arrt devant la cible: Mesure de la position et volution du graphe "SUIVI DE LIGNE" pendant 
;     884 // [4.3*10E-3*Phase_Arret] puis lancement du sous-programme Prise_Balle()
;     885 //------------------------------------------------------------------------------------------------------------ 
;     886 #if PARCOURS_ROBOT == AVEC_ARRET
;     887        if (Cible == 1) // Cible passe  1 lorsque le robot est devant la cible 
	SBRS R2,0
	RJMP _0x15B
;     888         {
;     889           if (Phase_Arret == 0)
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SBIW R30,0
	BRNE _0x15C
;     890                 Gestion_Balle(); // Cible <- dans INT0
	RCALL _Gestion_Balle
;     891                 else 
	RJMP _0x15D
_0x15C:
;     892                   Phase_Arret--;
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SBIW R30,1
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x15D:
;     893         }  
;     894 #endif
;     895 //============================================================================================================     
;     896 
;     897 /*============================================================================================================
;     898 // SUIVI DE LIGNE   
;     899 //============================================================================================================
;     900 //------------------------------------------------------------------------------------------------------------
;     901 // Dbut FS11: "Calculer la position du robot par rapport  la ligne" 		// !!!!! A COMPLETER PAR ELEVE
;     902 //------------------------------------------------------------------------------------------------------------          
;     903 Rle: Calculer une valeur numrique permettant de slectioner la LED IR (metteur IR) devant mettre
;     904 un faisceau infrarouge et calculer la valeur numrique reprsentative de la position du robot par
;     905 rapport  la ligne.
;     906 
;     907 Entre: 	AC0		 		bit    		Associ  la sortie du comparateur analogique (interne au C). 
;     908 							   			Reprsentatif de la position d'un capteur IR par rapport  la ligne.
;     909 
;     910 Sorties:    Cde_Del_IR 		octet   	Permet de multiplexer la commande des LED IR.
;     911 										Comme Cde_Del_IR est transfre dans le port A, on donne ci-dessous le
;     912           								dtail des bits de commande des LED IR.
;     913                                                 
;     914 					   					Emetteur IR connect  au bit      Remarque 
;     915 										----------------------------------------------------         
;     916 										E_D_IR		"      PA0    |   Emetteur IR droit
;     917 										E_CD_IR     "      PA1    |   Emetteur IR centre droit
;     918 										E_C_IR		"      PA2    |	  Emetteur IR centre
;     919 										E_CG_IR     "	   PA3	  |   Emetteur IR centre Gauche
;     920 										E_G_IR 		"      PA4    |	  Emetteur IR gauche 
;     921 					                                                
;     922 			Position_Robot	octet 		Image de la position du robot par rapport  la ligne
;     923 										(dtails dans RBELEVE.h)
;     924 
;     925 ------------------------------------------------------------------------------------------------------------*/ 
;     926       Position_Robot = HORS_LIGNE; // Initialisation  0	
_0x15B:
	CLR  R4
	CLR  R5
;     927       Cde_Del_IR = 1; 
	LDI  R20,LOW(1)
;     928  
;     929       for (i=0;i<5;i++)  // Dbut Acquisition de la position du robot par rapport  la ligne
	LDI  R16,LOW(0)
_0x15F:
	CPI  R16,5
	BRSH _0x160
;     930        {
;     931         CAPTEUR_IR = ~Cde_Del_IR;
	MOV  R30,R20
	CALL SUBOPT_0x17
;     932       	delay_us(30);	// Activation d'un capteur  ajuster   (19s par dfaut)
;     933         if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;
	SBIS 0x8,5
	RJMP _0x161
	MOV  R30,R20
	CALL SUBOPT_0x18
;     934         CAPTEUR_IR = 0xFF;
_0x161:
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     935         Cde_Del_IR = Cde_Del_IR << 1 ;
	LSL  R20
;     936         delay_us(540);	//  ajuster   (540s par dfaut)
	__DELAY_USW 1080
;     937        } 
	SUBI R16,-1
	RJMP _0x15F
_0x160:
;     938 // Fin FS11
;     939 //------------------------------------------------------------------------------------------------------------ 
;     940 
;     941                  
;     942 /*------------------------------------------------------------------------------------------------------------
;     943 // Dbut FS13 "Choisir la valeur  afficher sur les LEDs"				   		// !!!!! A COMPLETER PAR ELEVE
;     944 //------------------------------------------------------------------------------------------------------------ 
;     945 Rle: Choisir la valeur numrique ncessaire  la commande des LED rouge pour que leur clairage soit 
;     946 reprsentatif de la position du robot par rapport  la ligne noire.
;     947 
;     948 Entre 
;     949 Position_Robot: octet 	Reprsentatif de la position du robot. Les deux positions possibles sont traites dans
;     950 						RBELEVE.h (Connecteur du capteur vers l'avant ou connecteur du capteur vers l'arrire).
;     951 
;     952 Sortie
;     953 VisuPosition:  octet  	Reprsentatif des LED  clairer. Le bit 0 de VisuPosition commande la Led D0 de 
;     954 						l'interface IHM etc. Les valeurs  placer dans VisuPosition sont dfinies 
;     955 						dans le fichier RBELEVE.h
;     956 ------------------------------------------------------------------------------------------------------------*/                 
;     957 switch (Position_Robot)              
	__GETW1R 4,5
;     958        { 
;     959 // 		Position_Robot 			Modification de la valeur de commande des Leds       				
;     960 //------------------------------------------------------------------------------------------------------------
;     961 		case HORS_LIGNE:  		VisuPosition = Visu_Hors_ligne; break;			// Hors ligne
	SBIW R30,0
	BRNE _0x165
	LDI  R19,LOW(255)
	RJMP _0x164
;     962    		case GAUCHE_3PLUS:  	VisuPosition = Visu_GAUCHE_3PLUS; break;		// Gauche3+
_0x165:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x166
	LDI  R19,LOW(254)
	RJMP _0x164
;     963   		case GAUCHE_2PLUS:  	VisuPosition = Visu_GAUCHE_2PLUS; break;		// Gauche2+
_0x166:
	CPI  R30,LOW(0x18)
	LDI  R26,HIGH(0x18)
	CPC  R31,R26
	BRNE _0x167
	LDI  R19,LOW(252)
	RJMP _0x164
;     964    		case CENTRE_1:     		VisuPosition = Visu_CENTRE_1; break;			// Centre1 non visualis
_0x167:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x168
	LDI  R19,LOW(255)
	RJMP _0x164
;     965         case GAUCHE_PLUS:  		VisuPosition = Visu_GAUCHE_PLUS; break;			// Gauche+  
_0x168:
	CPI  R30,LOW(0x1C)
	LDI  R26,HIGH(0x1C)
	CPC  R31,R26
	BRNE _0x169
	LDI  R19,LOW(248)
	RJMP _0x164
;     966         case CENTRE_3: 	   		VisuPosition = Visu_CENTRE_3; break;			// Centre3 
_0x169:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BRNE _0x16A
	LDI  R19,LOW(255)
	RJMP _0x164
;     967         case GAUCHE: 			VisuPosition = Visu_GAUCHE; break;				// Gauche 
_0x16A:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x16B
	LDI  R19,LOW(240)
	RJMP _0x164
;     968         case DROITE_3PLUS: 		VisuPosition = Visu_DROITE_3PLUS; break;		// Droite3+
_0x16B:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x16C
	LDI  R19,LOW(239)
	RJMP _0x164
;     969         case DROITE_2PLUS: 		VisuPosition = Visu_DROITE_2PLUS; break;		// Droite2+  
_0x16C:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x16D
	LDI  R19,LOW(231)
	RJMP _0x164
;     970         case DROITE_PLUS:  		VisuPosition = Visu_DROITE_PLUS; break;			// Droite+ 
_0x16D:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x16E
	LDI  R19,LOW(227)
	RJMP _0x164
;     971         case DROITE: 	   		VisuPosition = Visu_DROITE; break;				// Droite 
_0x16E:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0x16F
	LDI  R19,LOW(225)
	RJMP _0x164
;     972         case CENTRE_5: 			VisuPosition = Visu_CENTRE_5; break;			// Centre5   
_0x16F:
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	BRNE _0x171
	LDI  R19,LOW(224)
	RJMP _0x164
;     973         default :				VisuPosition = 0b00011111; break;				// Visu_Erreur_mesure_ligne
_0x171:
	LDI  R19,LOW(31)
;     974        }     
_0x164:
;     975        
;     976 		Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuPosition);  		// Ecriture sur les LED via le bus I2C     
	LDI  R30,LOW(64)
	ST   -Y,R30
	ST   -Y,R19
	CALL _Ecrire_Port_I2C_Soft
;     977 // Fin FS13   
;     978 //------------------------------------------------------------------------------------------------------------
;     979     
;     980 
;     981 /*------------------------------------------------------------------------------------------------------------ 
;     982 // Dbut FS12: "Choisir les valeurs des rapports cycliques"					// !!!!!! A COMPLETER PAR ELEVE
;     983 //------------------------------------------------------------------------------------------------------------     
;     984 Rle: Choisir la valeur du rapport cyclique du signal de commande des moteurs du robot en fonction de
;     985 sa position par rapport  la ligne noire.
;     986 
;     987 Entre:          Position_Robot           octet     (voir ci-dessus)    
;     988 
;     989 Sorties:         CDE_MOTD                 octet		Correspond au registre (OCR1A). Rgle le rapport cyclique 
;     990 													du signal de commande du moteur droit.
;     991 				 CDE_MOTG                 octet     Correspond au registre (OCR1B). Rgle le rapport cyclique
;     992 				 							 		du signal de commande du moteur gauche.
;     993 ------------------------------------------------------------------------------------------------------------*/ 
;     994 // Graphe d'tat du suivi de ligne
;     995 //------------------------------------------------------------------------------------------------------------
;     996 // Dpart
;     997       switch (EtatCdeMot)              
	__GETW1R 12,13
;     998        { // Dbut switch (EtatCdeMot)                                 
;     999         case DEPART: Arret_Moteurs(); 
	SBIW R30,0
	BRNE _0x175
	CALL _Arret_Moteurs
;    1000         		if ((Position_Robot == CENTRE_1)||(Position_Robot == CENTRE_3)||(Position_Robot == CENTRE_5))
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R30,R4
	CPC  R31,R5
	BREQ _0x177
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	CP   R30,R4
	CPC  R31,R5
	BREQ _0x177
	LDI  R30,LOW(31)
	LDI  R31,HIGH(31)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x176
_0x177:
;    1001         		    { 
;    1002         		      Active_Moteurs();
	CALL _Active_Moteurs
;    1003         		      EtatCdeMot = CDE_CENTRE;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 12,13
;    1004         		    }
;    1005         		    else  EtatCdeMot = DEPART;
	RJMP _0x179
_0x176:
	CLR  R12
	CLR  R13
_0x179:
;    1006         break;   
	RJMP _0x174
;    1007 //------------------------------------------------------------------------------------------------------------
;    1008 // Suivi de ligne        
;    1009         case CDE_CENTRE : CDE_MOTG = PWM[0][0]; CDE_MOTD = PWM[0][1];
_0x175:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x17A
	CALL SUBOPT_0x1B
;    1010                           if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x17B
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1R 12,13
;    1011                           	else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	RJMP _0x17C
_0x17B:
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x17D
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	__PUTW1R 12,13
;    1012                           		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
	RJMP _0x17E
_0x17D:
	MOV  R0,R4
	OR   R0,R5
	BRNE _0x17F
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RJMP _0x29B
;    1013                           			else EtatCdeMot = CDE_CENTRE;
_0x17F:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x29B:
	__PUTW1R 12,13
_0x17E:
_0x17C:
;    1014         break;  
	RJMP _0x174
;    1015         
;    1016         
;    1017         case CDE_DROITE:CDE_MOTG = PWM[1][0]; CDE_MOTD = PWM[1][1]; 
_0x17A:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x181
	LDD  R30,Y+9
	OUT  0x28,R30
	MOVW R30,R28
	ADIW R30,10
	CALL SUBOPT_0x1C
;    1018                          if (Position_Robot == CENTRE_5 ) EtatCdeMot = CDE_CENTRE;
	BRNE _0x182
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 12,13
;    1019                           	else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
	RJMP _0x183
_0x182:
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x184
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1R 12,13
;    1020                            		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
	RJMP _0x185
_0x184:
	MOV  R0,R4
	OR   R0,R5
	BRNE _0x186
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RJMP _0x29C
;    1021                           			else EtatCdeMot = CDE_DROITE;
_0x186:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
_0x29C:
	__PUTW1R 12,13
_0x185:
_0x183:
;    1022         break;   
	RJMP _0x174
;    1023         
;    1024         case CDE_DROITE_PLUS:CDE_MOTG = PWM[2][0]; CDE_MOTD = PWM[2][1];
_0x181:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x188
	LDD  R30,Y+11
	OUT  0x28,R30
	MOVW R30,R28
	ADIW R30,12
	LD   R30,Z
	OUT  0x2A,R30
;    1025         		if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x189
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1R 12,13
;    1026                              else if (Position_Robot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS;
	RJMP _0x18A
_0x189:
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x18B
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x29D
;    1027                         		else EtatCdeMot = CDE_DROITE_PLUS;
_0x18B:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
_0x29D:
	__PUTW1R 12,13
_0x18A:
;    1028         break;  
	RJMP _0x174
;    1029         
;    1030         case CDE_DROITE_2PLUS: CDE_MOTG = PWM[3][0]; CDE_MOTD = PWM[3][1];
_0x188:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x18D
	LDD  R30,Y+13
	OUT  0x28,R30
	MOVW R30,R28
	ADIW R30,14
	LD   R30,Z
	OUT  0x2A,R30
;    1031         		if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS; 
	LDI  R30,LOW(28)
	LDI  R31,HIGH(28)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x18E
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1R 12,13
;    1032         	       		else if (Position_Robot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
	RJMP _0x18F
_0x18E:
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x190
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0x29E
;    1033         			   		else EtatCdeMot = CDE_DROITE_2PLUS;
_0x190:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
_0x29E:
	__PUTW1R 12,13
_0x18F:
;    1034         break;
	RJMP _0x174
;    1035              
;    1036         case CDE_DROITE_3PLUS: CDE_MOTG = PWM[4][0]; CDE_MOTD = PWM[4][1];
_0x18D:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x192
	LDD  R30,Y+15
	OUT  0x28,R30
	MOVW R30,R28
	ADIW R30,16
	LD   R30,Z
	OUT  0x2A,R30
;    1037         		if (Position_Robot == GAUCHE_2PLUS) EtatCdeMot = CDE_DROITE_2PLUS; 
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x193
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1R 12,13
;    1038         	       		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_HORS_LIGNE_DROITE;
	RJMP _0x194
_0x193:
	MOV  R0,R4
	OR   R0,R5
	BRNE _0x195
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	RJMP _0x29F
;    1039         					else EtatCdeMot = CDE_DROITE_3PLUS;
_0x195:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
_0x29F:
	__PUTW1R 12,13
_0x194:
;    1040         break;
	RJMP _0x174
;    1041         
;    1042         case CDE_HORS_LIGNE_DROITE : CDE_MOTG = PWM[5][0]; CDE_MOTD = PWM[5][1];
_0x192:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BRNE _0x197
	LDD  R30,Y+17
	OUT  0x28,R30
	MOVW R30,R28
	ADIW R30,18
	LD   R30,Z
	OUT  0x2A,R30
;    1043         		if (Position_Robot == GAUCHE_3PLUS) EtatCdeMot = CDE_DROITE_3PLUS;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x198
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0x2A0
;    1044         				else EtatCdeMot = CDE_HORS_LIGNE_DROITE;
_0x198:
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
_0x2A0:
	__PUTW1R 12,13
;    1045         break;
	RJMP _0x174
;    1046         			  			  
;    1047         case CDE_GAUCHE: CDE_MOTG = PWM[6][0]; CDE_MOTD = PWM[6][1]; 
_0x197:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x19A
	LDD  R30,Y+19
	OUT  0x28,R30
	MOVW R30,R28
	ADIW R30,20
	CALL SUBOPT_0x1C
;    1048                        if (Position_Robot == CENTRE_5) EtatCdeMot = CDE_CENTRE;
	BRNE _0x19B
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 12,13
;    1049                           	else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;  
	RJMP _0x19C
_0x19B:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x19D
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	__PUTW1R 12,13
;    1050                           		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_COUPURE;
	RJMP _0x19E
_0x19D:
	MOV  R0,R4
	OR   R0,R5
	BRNE _0x19F
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	RJMP _0x2A1
;    1051                           			else EtatCdeMot = CDE_GAUCHE;
_0x19F:
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
_0x2A1:
	__PUTW1R 12,13
_0x19E:
_0x19C:
;    1052         break;  
	RJMP _0x174
;    1053         
;    1054         case CDE_GAUCHE_PLUS: CDE_MOTG = PWM[7][0]; CDE_MOTD = PWM[7][1]; 
_0x19A:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x1A1
	LDD  R30,Y+21
	OUT  0x28,R30
	MOVW R30,R28
	ADIW R30,22
	LD   R30,Z
	OUT  0x2A,R30
;    1055                       if  (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x1A2
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	__PUTW1R 12,13
;    1056         	              else if (Position_Robot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
	RJMP _0x1A3
_0x1A2:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x1A4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP _0x2A2
;    1057                                		else EtatCdeMot = CDE_GAUCHE_PLUS;
_0x1A4:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
_0x2A2:
	__PUTW1R 12,13
_0x1A3:
;    1058         break; 
	RJMP _0x174
;    1059         
;    1060         case CDE_GAUCHE_2PLUS: CDE_MOTG = PWM[8][0]; CDE_MOTD = PWM[8][1];
_0x1A1:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x1A6
	LDD  R30,Y+23
	OUT  0x28,R30
	MOVW R30,R28
	ADIW R30,24
	LD   R30,Z
	OUT  0x2A,R30
;    1061         		if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x1A7
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	__PUTW1R 12,13
;    1062         		        else if (Position_Robot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
	RJMP _0x1A8
_0x1A7:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x1A9
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	RJMP _0x2A3
;    1063         					else EtatCdeMot = CDE_GAUCHE_2PLUS;
_0x1A9:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
_0x2A3:
	__PUTW1R 12,13
_0x1A8:
;    1064         break;
	RJMP _0x174
;    1065         
;    1066         case CDE_GAUCHE_3PLUS: CDE_MOTG = PWM[9][0]; CDE_MOTD = PWM[9][1];
_0x1A6:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x1AB
	LDD  R30,Y+25
	OUT  0x28,R30
	MOVW R30,R28
	ADIW R30,26
	LD   R30,Z
	OUT  0x2A,R30
;    1067         		if (Position_Robot == DROITE_2PLUS) EtatCdeMot = CDE_GAUCHE_2PLUS;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x1AC
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	__PUTW1R 12,13
;    1068         	       		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = CDE_HORS_LIGNE_GAUCHE; 
	RJMP _0x1AD
_0x1AC:
	MOV  R0,R4
	OR   R0,R5
	BRNE _0x1AE
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RJMP _0x2A4
;    1069         					else EtatCdeMot = CDE_GAUCHE_3PLUS;
_0x1AE:
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
_0x2A4:
	__PUTW1R 12,13
_0x1AD:
;    1070         break;
	RJMP _0x174
;    1071         
;    1072         case CDE_HORS_LIGNE_GAUCHE: CDE_MOTG = PWM[10][0]; CDE_MOTD = PWM[10][1];
_0x1AB:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x1B0
	LDD  R30,Y+27
	OUT  0x28,R30
	MOVW R30,R28
	ADIW R30,28
	LD   R30,Z
	OUT  0x2A,R30
;    1073         		if (Position_Robot == DROITE_3PLUS) EtatCdeMot = CDE_GAUCHE_3PLUS;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x1B1
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	RJMP _0x2A5
;    1074         				else EtatCdeMot = CDE_HORS_LIGNE_GAUCHE;
_0x1B1:
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
_0x2A5:
	__PUTW1R 12,13
;    1075         break;
	RJMP _0x174
;    1076         
;    1077         case CDE_COUPURE: CDE_MOTG = PWM[0][0]; CDE_MOTD = PWM[0][1];
_0x1B0:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x1C1
	CALL SUBOPT_0x1B
;    1078                           switch(Position_Robot)
	__GETW1R 4,5
;    1079                           {
;    1080                             case CENTRE_5:  EtatCdeMot = CDE_CENTRE; break;   
	CPI  R30,LOW(0x1F)
	LDI  R26,HIGH(0x1F)
	CPC  R31,R26
	BRNE _0x1B7
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 12,13
	RJMP _0x1B6
;    1081                             case GAUCHE:   EtatCdeMot = CDE_DROITE; break;
_0x1B7:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x1B8
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1R 12,13
	RJMP _0x1B6
;    1082                             case GAUCHE_PLUS:   EtatCdeMot = CDE_DROITE_PLUS; break;
_0x1B8:
	CPI  R30,LOW(0x1C)
	LDI  R26,HIGH(0x1C)
	CPC  R31,R26
	BRNE _0x1B9
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1R 12,13
	RJMP _0x1B6
;    1083                             case GAUCHE_2PLUS:   EtatCdeMot = CDE_DROITE_2PLUS; break;
_0x1B9:
	CPI  R30,LOW(0x18)
	LDI  R26,HIGH(0x18)
	CPC  R31,R26
	BRNE _0x1BA
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1R 12,13
	RJMP _0x1B6
;    1084                             case GAUCHE_3PLUS:   EtatCdeMot = CDE_DROITE_3PLUS; break;
_0x1BA:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x1BB
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	__PUTW1R 12,13
	RJMP _0x1B6
;    1085                             case DROITE:   EtatCdeMot = CDE_GAUCHE ; break;
_0x1BB:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0x1BC
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	__PUTW1R 12,13
	RJMP _0x1B6
;    1086                             case DROITE_PLUS:   EtatCdeMot = CDE_GAUCHE_PLUS; break;
_0x1BC:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x1BD
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	__PUTW1R 12,13
	RJMP _0x1B6
;    1087                             case DROITE_2PLUS:   EtatCdeMot = CDE_GAUCHE_2PLUS; break;
_0x1BD:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x1BE
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	__PUTW1R 12,13
	RJMP _0x1B6
;    1088                             case DROITE_3PLUS:   EtatCdeMot = CDE_GAUCHE_3PLUS; break;
_0x1BE:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x1C0
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	__PUTW1R 12,13
	RJMP _0x1B6
;    1089                             default: EtatCdeMot = CDE_COUPURE; break;  
_0x1C0:
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	__PUTW1R 12,13
;    1090                           }
_0x1B6:
;    1091         
;    1092         break;
	RJMP _0x174
;    1093         
;    1094         default : EtatCdeMot = CDE_CENTRE; 
_0x1C1:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 12,13
;    1095         break;
;    1096         
;    1097 // Fin FS12 
;    1098 //------------------------------------------------------------------------------------------------------------        
;    1099        }// Fin switch (EtatCdeMot)        
_0x174:
;    1100 //------------------------------------------------------------------------------------------------------------
;    1101    
;    1102 // Fin Traiter 
;    1103 //============================================================================================================
;    1104        delay_us(2000); //  ajuster   (704s  par dfaut) 
	__DELAY_USW 4000
;    1105 //============================================================================================================		
;    1106     }
	RJMP _0x158
;    1107 } // fin Mode_Run();
	CALL __LOADLOCR5
	ADIW R28,29
	RET
;    1108 //============================================================================================================   
;    1109 
;    1110 //============================================================================================================ 
;    1111 //============================================================================================================
;    1112 // *************************** SOUS-PROGRAMME GESTION DE LA BALLE ELEVE **************************************
;    1113 //============================================================================================================
;    1114 //============================================================================================================
;    1115 #if PARCOURS_ROBOT == AVEC_ARRET
;    1116 void Gestion_Balle(void)
;    1117 {
_Gestion_Balle:
;    1118 // Dsactivation de la dtection de la cible
;    1119 Cible = 0; 
	CLT
	BLD  R2,0
;    1120 //---------------------------------------------------------
;    1121 // A complter par lve
;    1122 //---------------------------------------------------------
;    1123 //
;    1124 CDE_SERVO1 = 1; // Libration balle
	SBI  0x12,6
;    1125 delay_ms(300);
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1126 CDE_SERVO1 = 0; // Arrt dclenchement 
	CBI  0x12,6
;    1127 CDE_SERVO2 = 1;  
	SBI  0x12,7
;    1128 delay_ms(1500);
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1129 //---------------------------------------------------------
;    1130 // Marche Robot 
;    1131 //---------------------------------------------------------
;    1132 Active_Moteurs();  
	CALL _Active_Moteurs
;    1133 //---------------------------------------------------------
;    1134 }
	RET
;    1135 #endif
;    1136 //============================================================================================================
;    1137 //============================================================================================================
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	put:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x1F9
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x1FA
_0x1F9:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _putchar
_0x1FA:
	ADIW R28,3
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R16,0
_0x1FC:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x1FE
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x202
	CPI  R19,37
	BRNE _0x203
	LDI  R16,LOW(1)
	RJMP _0x204
_0x203:
	CALL SUBOPT_0x1D
_0x204:
	RJMP _0x201
_0x202:
	CPI  R30,LOW(0x1)
	BRNE _0x205
	CPI  R19,37
	BRNE _0x206
	CALL SUBOPT_0x1D
	LDI  R16,LOW(0)
	RJMP _0x201
_0x206:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x207
	LDI  R17,LOW(1)
	RJMP _0x201
_0x207:
	CPI  R19,43
	BRNE _0x208
	LDI  R21,LOW(43)
	RJMP _0x201
_0x208:
	CPI  R19,32
	BRNE _0x209
	LDI  R21,LOW(32)
	RJMP _0x201
_0x209:
	RJMP _0x20A
_0x205:
	CPI  R30,LOW(0x2)
	BRNE _0x20B
_0x20A:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x20C
	ORI  R17,LOW(128)
	RJMP _0x201
_0x20C:
	RJMP _0x20D
_0x20B:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x201
_0x20D:
	CPI  R19,48
	BRLO _0x210
	CPI  R19,58
	BRLO _0x211
_0x210:
	RJMP _0x20F
_0x211:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x201
_0x20F:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x215
	CALL SUBOPT_0x1E
	LD   R30,X
	CALL SUBOPT_0x1F
	RJMP _0x216
_0x215:
	CPI  R30,LOW(0x73)
	BRNE _0x218
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x20
	CALL _strlen
	MOV  R16,R30
	RJMP _0x219
_0x218:
	CPI  R30,LOW(0x70)
	BRNE _0x21B
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x20
	CALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x219:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x21C
_0x21B:
	CPI  R30,LOW(0x64)
	BREQ _0x21F
	CPI  R30,LOW(0x69)
	BRNE _0x220
_0x21F:
	ORI  R17,LOW(4)
	RJMP _0x221
_0x220:
	CPI  R30,LOW(0x75)
	BRNE _0x222
_0x221:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x223
_0x222:
	CPI  R30,LOW(0x58)
	BRNE _0x225
	ORI  R17,LOW(8)
	RJMP _0x226
_0x225:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x254
_0x226:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x223:
	SBRS R17,2
	RJMP _0x228
	CALL SUBOPT_0x1E
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x229
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x229:
	CPI  R21,0
	BREQ _0x22A
	SUBI R16,-LOW(1)
	RJMP _0x22B
_0x22A:
	ANDI R17,LOW(251)
_0x22B:
	RJMP _0x22C
_0x228:
	CALL SUBOPT_0x1E
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x22C:
_0x21C:
	SBRC R17,0
	RJMP _0x22D
_0x22E:
	CP   R16,R20
	BRSH _0x230
	SBRS R17,7
	RJMP _0x231
	SBRS R17,2
	RJMP _0x232
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x233
_0x232:
	LDI  R19,LOW(48)
_0x233:
	RJMP _0x234
_0x231:
	LDI  R19,LOW(32)
_0x234:
	CALL SUBOPT_0x1D
	SUBI R20,LOW(1)
	RJMP _0x22E
_0x230:
_0x22D:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x235
_0x236:
	CPI  R18,0
	BREQ _0x238
	SBRS R17,3
	RJMP _0x239
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x2A6
_0x239:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2A6:
	ST   -Y,R30
	CALL SUBOPT_0x21
	CPI  R20,0
	BREQ _0x23B
	SUBI R20,LOW(1)
_0x23B:
	SUBI R18,LOW(1)
	RJMP _0x236
_0x238:
	RJMP _0x23C
_0x235:
_0x23E:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x240
	SBRS R17,3
	RJMP _0x241
	SUBI R19,-LOW(7)
	RJMP _0x242
_0x241:
	SUBI R19,-LOW(39)
_0x242:
_0x240:
	SBRC R17,4
	RJMP _0x244
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x246
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x245
_0x246:
	ORI  R17,LOW(16)
	RJMP _0x248
_0x245:
	CP   R20,R18
	BRLO _0x24A
	SBRS R17,0
	RJMP _0x24B
_0x24A:
	RJMP _0x249
_0x24B:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x24C
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x248:
	SBRS R17,2
	RJMP _0x24D
	ANDI R17,LOW(251)
	ST   -Y,R21
	CALL SUBOPT_0x21
	CPI  R20,0
	BREQ _0x24E
	SUBI R20,LOW(1)
_0x24E:
_0x24D:
_0x24C:
_0x244:
	CALL SUBOPT_0x1D
	CPI  R20,0
	BREQ _0x24F
	SUBI R20,LOW(1)
_0x24F:
_0x249:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x23F
	RJMP _0x23E
_0x23F:
_0x23C:
	SBRS R17,0
	RJMP _0x250
_0x251:
	CPI  R20,0
	BREQ _0x253
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1F
	RJMP _0x251
_0x253:
_0x250:
_0x254:
_0x216:
	LDI  R16,LOW(0)
_0x201:
	RJMP _0x1FC
_0x1FE:
	CALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	CALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G2
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	RJMP _0x283
_fmod:
	SBIW R28,4
	__GETD1S 4
	CALL __CPD10
	BRNE _0x257
	__GETD1N 0x0
	RJMP _0x285
_0x257:
	__GETD1S 4
	__GETD2S 8
	CALL __DIVF21
	__PUTD1S 0
	CALL __CPD10
	BRNE _0x258
	__GETD1N 0x0
	RJMP _0x285
_0x258:
	__GETD2S 0
	CALL __CPD02
	BRGE _0x259
	__GETD1S 0
	CALL __PUTPARD1
	CALL _floor
	RJMP _0x2A7
_0x259:
	__GETD1S 0
	CALL __PUTPARD1
	CALL _ceil
_0x2A7:
	__PUTD1S 0
	__GETD2S 4
	CALL __MULF12
	__GETD2S 8
	CALL __SWAPD12
	CALL __SUBF12
_0x285:
	ADIW R28,12
	RET
_Lire_BP_I2C_Soft:

	.DSEG
_Etat_BP_I2C_SA:
	.BYTE 0x2

	.CSEG
	ST   -Y,R17
	ST   -Y,R16
	CALL SUBOPT_0x4
	MOV  R16,R30
	LDS  R30,_Etat_BP_I2C_SA
	LDS  R31,_Etat_BP_I2C_SA+1
	SBIW R30,0
	BRNE _0x265
	CPI  R16,0
	BRNE _0x266
	MOV  R17,R16
	CALL SUBOPT_0x22
	MOV  R16,R30
	CP   R16,R17
	BRNE _0x267
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _Etat_BP_I2C_SA,R30
	STS  _Etat_BP_I2C_SA+1,R31
	CLR  R30
	RJMP _0x284
_0x267:
	LDI  R30,LOW(255)
	RJMP _0x284
	RJMP _0x269
_0x266:
	LDI  R30,LOW(255)
	RJMP _0x284
_0x269:
	RJMP _0x264
_0x265:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x264
	CPI  R16,0
	BREQ _0x26B
	MOV  R17,R16
	CALL SUBOPT_0x22
	MOV  R16,R30
	CP   R16,R17
	BRNE _0x26C
	CLR  R30
	STS  _Etat_BP_I2C_SA,R30
	STS  _Etat_BP_I2C_SA+1,R30
	MOV  R30,R16
	RJMP _0x284
_0x26C:
	CLR  R30
	RJMP _0x284
	RJMP _0x26E
_0x26B:
	CLR  R30
_0x26E:
_0x264:
_0x284:
	LD   R16,Y+
	LD   R17,Y+
	RET
_Affiche_LCD:
	CALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	CLR  R30
	CALL SUBOPT_0x11
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
_0x283:
	ADIW R28,4
	RET
_Arret_Moteurs:
	CLR  R30
	OUT  0x2F,R30
	OUT  0x2E,R30
	LDI  R30,LOW(48)
	OUT  0x12,R30
	RET
_Active_Moteurs:
	CALL SUBOPT_0x0
	RET
_Affiche_Fleche:
	LDI  R30,LOW(15)
	CALL SUBOPT_0xE
	CALL SUBOPT_0x10
	LDI  R30,LOW(15)
	CALL SUBOPT_0x11
	CALL SUBOPT_0x12
	RET
_Ecrire_Port_I2C_Soft:
	CALL _i2c_start
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_stop
	ADIW R28,2
	RET
_Lire_Port_I2C_Soft:
	ST   -Y,R16
	CALL _i2c_start
	LDD  R30,Y+1
	ORI  R30,1
	ST   -Y,R30
	CALL _i2c_write
	CLR  R30
	ST   -Y,R30
	CALL _i2c_read
	MOV  R16,R30
	CALL _i2c_stop
	MOV  R30,R16
	LDD  R16,Y+0
	ADIW R28,2
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G8:
	.BYTE 0x4
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_write_byte:
	CALL __lcd_ready
	LDD  R30,Y+1
	CALL SUBOPT_0x23
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	ST   -Y,R30
	CALL __lcd_write_data
	ADIW R28,2
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G8:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G8)
	SBCI R31,HIGH(-__base_y_G8)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R14,Y+1
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	CALL SUBOPT_0x23
	LDI  R30,LOW(12)
	CALL SUBOPT_0x23
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	CLR  R30
	STS  __lcd_y,R30
	MOV  R14,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R14
	LDS  R30,__lcd_maxx
	CP   R30,R14
	BRSH _0x27C
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	CLR  R30
	ST   -Y,R30
	LDS  R30,__lcd_y
	ST   -Y,R30
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0x27C:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G8:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G8:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G8,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G8,3
	CALL SUBOPT_0x24
	CALL SUBOPT_0x24
	CALL SUBOPT_0x24
	CALL __long_delay_G8
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G8
	CALL __long_delay_G8
	LDI  R30,LOW(40)
	CALL SUBOPT_0x25
	LDI  R30,LOW(4)
	CALL SUBOPT_0x25
	LDI  R30,LOW(133)
	CALL SUBOPT_0x25
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G8
	CPI  R30,LOW(0x5)
	BREQ _0x281
	CLR  R30
	RJMP _0x282
_0x281:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x282:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(241)
	OUT  0x2F,R30
	LDI  R30,LOW(1)
	OUT  0x2E,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	MOV  R30,R18
	CLR  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x2:
	CALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0x3:
	CALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	JMP  _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(66)
	ST   -Y,R30
	JMP  _Lire_Port_I2C_Soft

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x5:
	LDD  R30,Y+56
	LDD  R31,Y+56+1
	CALL __CWD1
	CALL __CDF1
	CALL __PUTPARD1
	__GETD1N 0x40000000
	CALL __PUTPARD1
	CALL _fmod
	CALL __CPD10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x6:
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+58
	LDD  R31,Y+58+1
	ASR  R31
	ROR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x7:
	CALL _sprintf
	ADIW R28,4
	LDD  R30,Y+56
	LDD  R31,Y+56+1
	ASR  R31
	ROR  R30
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x8:
	CALL __EEPROMRDB
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x9:
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	JMP  _strcat

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+58
	LDD  R31,Y+58+1
	ASR  R31
	ROR  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,1
	MOVW R26,R30
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	JMP  _strcat

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xE:
	ST   -Y,R30
	CLR  R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(37)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(15)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	CLR  R30
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x11:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x13:
	LDD  R30,Y+56
	LDD  R31,Y+56+1
	ASR  R31
	ROR  R30
	LDI  R26,LOW(_PWM_EEPROM)
	LDI  R27,HIGH(_PWM_EEPROM)
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	LDD  R30,Y+13
	LDD  R26,Y+12
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x15:
	CALL _sprintf
	ADIW R28,8
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	LDD  R26,Y+13
	LDI  R30,LOW(10)
	CALL __DIVB21U
	CLR  R31
	MOVW R26,R28
	ADIW R26,1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	COM  R30
	OUT  0x1B,R30
	__DELAY_USB 80
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	__GETW2R 4,5
	CLR  R31
	OR   R30,R26
	OR   R31,R27
	__PUTW1R 4,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	LDI  R26,LOW(_Table_Calcul_OCR1x*2)
	LDI  R27,HIGH(_Table_Calcul_OCR1x*2)
	MOV  R30,R18
	CLR  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	LDD  R30,Y+7
	OUT  0x28,R30
	LDD  R30,Y+8
	OUT  0x2A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	LD   R30,Z
	OUT  0x2A,R30
	LDI  R30,LOW(31)
	LDI  R31,HIGH(31)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x1D:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x1E:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	CALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x23:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x24:
	CALL __long_delay_G8
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x25:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G8

	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_itoa:
	ld   r26,y+
	ld   r27,y+
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	brpl __itoa0
	com  r30
	com  r31
	adiw r30,1
	ldi  r22,'-'
	st   x+,r22
__itoa0:
	clt
	ldi  r24,low(10000)
	ldi  r25,high(10000)
	rcall __itoa1
	ldi  r24,low(1000)
	ldi  r25,high(1000)
	rcall __itoa1
	ldi  r24,100
	clr  r25
	rcall __itoa1
	ldi  r24,10
	rcall __itoa1
	mov  r22,r30
	rcall __itoa5
	clr  r22
	st   x,r22
	ret
__itoa1:
	clr	 r22
__itoa2:
	cp   r30,r24
	cpc  r31,r25
	brlo __itoa3
	inc  r22
	sub  r30,r24
	sbc  r31,r25
	brne __itoa2
__itoa3:
	tst  r22
	brne __itoa4
	brts __itoa5
	ret
__itoa4:
	set
__itoa5:
	subi r22,-0x30
	st   x+,r22
	ret

_strcat:
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
	movw r24,r26
__strcat0:
	ld   r22,x+
	tst  r22
	brne __strcat0
	sbiw r26,1
__strcat1:
	ld   r22,z+
	st   x+,r22
	tst  r22
	brne __strcat1
	movw r30,r24
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

	rjmp __addfc

_ceil:
	rcall __ftrunc
	brne __ceil1
__ceil0:
	ret
__ceil1:
	brts __ceil0
	ldi  r25,0x3f

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIC EECR,EEWE
	RJMP __EEPROMWRB
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	MOV  R21,R30
	MOV  R30,R26
	MOV  R26,R21
	MOV  R21,R31
	MOV  R31,R27
	MOV  R27,R21
	MOV  R21,R22
	MOV  R22,R24
	MOV  R24,R21
	MOV  R21,R23
	MOV  R23,R25
	MOV  R25,R21
	MOV  R21,R0
	MOV  R0,R1
	MOV  R1,R21
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __MAXRES
	RJMP __MINRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

